;---------------
StartMenu
	DI
	LD SP,65530			;stack
	EI
		
	
;Drawing Menu		
	CALL ClearScreen
		
	LD HL,18432+9
	LD DE,MenuText
	CALL TypeText
	
	LD HL,18432+230
	LD DE,MenuText2
	CALL TypeText
	
	CALL ShowPointer
		
	LD A,1
	LD (LevelNr),A
	
	CALL 40631			;playing music
	
StartMenu2
;testing keyboard
	LD BC,63486
	IN A,(C)
		
	BIT 0,A				;choose keys
	JR Z,SetKeys
			
	BIT 1,A				;choose joystick	
	JR Z,SetJoy
			
	BIT 2,A				;start level
	JP Z,StartLevel
	
	JR StartMenu2
;------		
SetKeys
	XOR A
	LD (KeysOrJoystick),A	
	CALL ShowPointer
	CALL Sound1
	JR StartMenu2
		
SetJoy
	LD A,1
	LD (KeysOrJoystick),A	
	CALL ShowPointer
	CALL Sound1
	JR StartMenu2
	
;------
ShowPointer
	LD DE,Pointer
	LD A,(KeysOrJoystick)
	OR A
	JR NZ,ShowPointer2
	
	LD HL,18472			;point keyboard
	CALL DrawTile
	RET	
	
ShowPointer2
	LD HL,18472+32		;point joystick
	CALL DrawTile
	RET	
;---------------
StartLevel
	DI
	LD SP,65530
	EI
	LD A,(LevelNr)
	CALL DrawLevelScreen
	
	LD A,(LevelNr)
	CP 1
	JP Z,PlayPuzzle1
	CP 2
	JP Z,PlayPuzzle2
	CP 3
	JP Z,PlayPuzzle3
StartLevel2
	JR StartLevel2
;---------------
DrawLevelScreen
	CALL ClearScreen
	LD HL,16384+234
	LD DE,Level
	CALL DrawTile
		
	LD A,(LevelNr)	
	CP 1
	JR Z,DrawLevelScreen_Level1	
	CP 2
	JR Z,DrawLevelScreen_Level2
	CP 3
	JR Z,DrawLevelScreen_Level3
	
DrawLevelScreen_Level1	
	LD HL,18432+104
	LD DE,Level1Text
	CALL TypeText
	LD DE,One
	JR DrawLevelScreen3
	
DrawLevelScreen_Level2	
	LD HL,18432+104
	LD DE,Level2Text
	CALL TypeText
	LD DE,Two
	JR DrawLevelScreen3
	
DrawLevelScreen_Level3	
	LD HL,18432+105
	LD DE,Level3Text
	CALL TypeText
	LD DE,Three
	
DrawLevelScreen3
	LD HL,16384+244
	CALL DrawTile
	
	LD B,180
DrawLevelScreen4
	HALT
	DJNZ DrawLevelScreen4
	CALL FadeOut
	RET
;--------
LevelNr		.BYTE 0

;--------------------------
DrawEndOfLevelScreen
	CALL ClearScreen
	LD HL,18473
	LD DE,LevelCompletedText
	CALL TypeText
	
	LD B,100
DrawEndOfLevelScreen2
	HALT
	DJNZ DrawEndOfLevelScreen2
	
	
	CALL FadeOut
		
	RET
	
;------------
FadeOut	
	LD A,6	

FadeOut2	
	HALT
	HALT
	HALT
	LD HL,22528
	LD DE,22529
	LD BC,767
	LD (HL),A
	LDIR
	DEC A
	JR NZ,FadeOut2	
	CALL ClearScreen
	RET
	
;-------------------------
Ending
	CALL ClearScreen
	LD IX,Ending_Pos
	
	LD B,4
Ending2
	PUSH BC
	CALL EndingDelay
	CALL Sound3
	LD H,(IX+0)
	LD L,(IX+1)	
	LD DE,Ending_A
	CALL DrawTile
	INC IX
	INC IX
	CALL EndingDelay
	CALL Sound3
	LD H,(IX+0)
	LD L,(IX+1)	
	LD DE,Ending_B
	CALL DrawTile
	INC IX
	INC IX
	POP BC
	DJNZ Ending2
	
	CALL EndingDelay
	LD DE,CongratText
	LD HL,16384+192+8
	CALL TypeText


	CALL 40631			;playing music
	CALL EndingDelay
	JP StartMenu
	
	

	
;-------------------------
GameOver	
	CALL ClearScreen
	LD HL,18436+104
	LD DE,LosePic
	CALL DrawTile
	
	LD HL,16384+100
	LD DE,LoseText
	CALL TypeText

	LD B,250
GameOver2
	HALT
	DJNZ GameOver2
	CALL FadeOut
	
	LD HL,18432+108
	LD DE,Lose2Text
	CALL TypeText
	LD B,180
GameOver3
	HALT
	DJNZ GameOver3
	CALL FadeOut
	
	JP StartMenu
;---
EndingDelay
	LD B,50
EndingDelay2
	HALT
	DJNZ EndingDelay2
	RET
	

Ending_Pos
	.BYTE 80,144
	.BYTE 64 ,225
	.BYTE 64,7
	.BYTE 72,216
	.BYTE 72,192
	.BYTE 64,17
	.BYTE 64,247
	.BYTE 80,136
;---------------
Level:
	.BYTE 9,2
	.BYTE	  0,  0,  0,  8, 12,  6,  7,  3
	.BYTE	  0, 28, 63,115, 65,195,199,254
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  3,  7,  7, 15, 15, 15
	.BYTE	  0,240,248,152,152,152,176,224
	.BYTE	  1,  0,  0,126,207,129,243,124
	.BYTE	248,192,192,192,240,255, 31,  1
	.BYTE	  0,  0,  0,  1,  3,  3,251,241
	.BYTE	  0,  0,252,206,220,241,255,252
	.BYTE	  0,  0, 30, 63, 31,143, 15,  7
	.BYTE	  0,  0, 56, 57,155,147,227,193
	.BYTE	  0,  0,127,231,238,248,255,254
	.BYTE	 15, 15, 15,143, 15,111,199,  3
	.BYTE	224,192,128,128,134,140,248,240
	.BYTE	 70, 70,  0,  0,  0,  0,  0, 70
	.BYTE	 70, 70, 70, 70, 70, 70, 70, 70
	.BYTE	 70, 70
	
One:
	.BYTE 2,2
	.BYTE	  0,  0,  1,  3,  7, 15, 11,  3
	.BYTE	 48,248,248,248,240,240,240,240
	.BYTE	  3,  3,  3,  3,  3,  3,  3,  1
	.BYTE	240,240,240,240,240,224,192,128
	.BYTE	 70, 70, 70, 70

Two:
	.BYTE 2,2
	.BYTE	  3, 31,112,224,226,254,124, 48
	.BYTE	248,254,127, 63, 31, 31, 62,124
	.BYTE	  0,  1,  3, 15, 31, 63,127, 63
	.BYTE	248,224,129,  3,255,254,254,252
	.BYTE	 70, 70, 70, 70
	
Three:
	.BYTE 2,2
	.BYTE	  7, 63, 96,192,198,252,120,  3
	.BYTE	240,252,126, 62, 60,120,240,252
	.BYTE	  0,  0,  0,192,120,127, 63, 15
	.BYTE	254, 62, 14, 14, 28,248,224,128
	.BYTE	 70, 70, 70, 70

Ending_A	
	.BYTE 8,3
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0,  0,  3, 15, 63,127,  0,255
	.BYTE	  0,255,255,255,255,255,127,  0
	.BYTE	  0,128,255,255,255,255,255,127
	.BYTE	  0,  0,255,255,255,255,255,255
	.BYTE	  0,  0,128,255,255,255,252,225
	.BYTE	  0,  0,  0,255,248,131, 63,255
	.BYTE	  0,  0,  0,128,  0,192,224,224
	.BYTE	  0,  1,  1,  3,  3,  7,  7, 15
	.BYTE	  0, 32, 64,144, 32,  0,  4,  8
	.BYTE	  0,  0,  0,  1, 18, 32,  0,  0
	.BYTE	  0,255,255,255,255,255,255,255
	.BYTE	127,128,255,255,254,254,254,253
	.BYTE	159,127,127,127,255,254,253,250
	.BYTE	255,250,245,186, 84,168, 64,128
	.BYTE	 80,176, 88,136,  4,  4,  2,  2
	.BYTE	 15, 31, 31,  7,  0,  0,  0,  0
	.BYTE	255,255,255,255, 63,  1,  0,  0
	.BYTE	255,255,255,255,255,255,  7,  0
	.BYTE	255,255,255,254,245,234,240, 15
	.BYTE	253,233,219,171, 83, 23, 55,247
	.BYTE	253,250,244,232,240,235,252,192
	.BYTE	  0,  0,  0,  3, 60,192,  0,  0
	.BYTE	  1,  3, 60,192,  0,  0,  0,  0
	.BYTE	  0, 70, 70, 70, 70, 70, 70, 70
	.BYTE	 70,119,119, 70, 70, 70, 70,  6
	.BYTE	 70, 70, 70, 70, 70, 70,  6,  6
	
Ending_B
	.BYTE 6,3
	.BYTE	  0,  1,  3,  7, 14, 28, 56,112
	.BYTE	255,192,135, 24, 48,112,120, 32
	.BYTE	255,  0,224,112, 49, 50,229, 74
	.BYTE	255,  0, 95,182,101,236,127,173
	.BYTE	255,  0,254,103, 86,205,250, 85
	.BYTE	255,  7,174, 93,186,117,234,213
	.BYTE	224,255,  0,255,  0,255,  0,255
	.BYTE	  0,255,  0,255,  0,255,  0,255
	.BYTE	  0,255,  0,255,  0,255,  0,255
	.BYTE	  0,255,  0,255,  0,255,  0,255
	.BYTE	  3,255,  0,255,  0,255,  0,255
	.BYTE	170, 85,170, 85,170, 84,168, 80
	.BYTE	  0,255,  0,255,  0,  0,  0,  0
	.BYTE	  0,255,  0,255,  0,  0,  0,  0
	.BYTE	  0,255,  0,255,  0,  0,  0,  0
	.BYTE	  0,255,  0,255,  0,  0,  0,  0
	.BYTE	  0,255,  0,255,  0,  0,  0,  0
	.BYTE	160, 64,128,  0,  0,  0,  0,  0
	.BYTE	 68,  4,  4,  4,  4,  4, 68, 68
	.BYTE	 68, 68, 68,  4, 68, 68, 68, 68
	.BYTE	 68,  4
	
	
LosePic
	.BYTE 7,9
	.BYTE	  0,  1,  0,  8,  4,  0, 31,  0
	.BYTE	175, 85, 42,133, 18,  1,255,  0
	.BYTE	213,192,212, 65,210, 64,223,  0
	.BYTE	 85,170,  5, 16,130,  0,255,  0
	.BYTE	250,184, 90,168, 90, 40,251,  0
	.BYTE	170, 21,128, 34, 80,  0,255,  0
	.BYTE	  0, 64,160, 16, 64,  0,252,  0
	.BYTE	 62, 30, 46, 22, 14, 22, 10, 22
	.BYTE	255,208,255,  0,255,  0,  0,  0
	.BYTE	255,200,255,  0,255,  0, 66, 98
	.BYTE	255,233,255,  0,255,  0,  0,  0
	.BYTE	255, 50,255,  0,254,  0, 66, 98
	.BYTE	255, 45,255,  0,169,  0,  0,  0
	.BYTE	 92, 14, 86, 10, 71, 11, 69, 11
	.BYTE	 10,  6,  2,132,  2,128,234,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	114, 98,114,122, 82,106, 82,106
	.BYTE	126,129,  0,  0, 32,120,255, 24
	.BYTE	 82, 98, 82,106,114,106,114,122
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 69, 67,  1, 66,  1, 64,117,  0
	.BYTE	190, 30,174, 22,142, 22,138, 22
	.BYTE	  0,  0,  0,  0,  0,  0,  1,  7
	.BYTE	114,106,114,106,114,106,114,106
	.BYTE	255,231,255,195,126,  0,129,255
	.BYTE	 82,106, 82,106, 82,106, 82,106
	.BYTE	  0,  0,  0,  0,  0,  0,128,224
	.BYTE	 95, 15, 87, 11, 71, 11, 69, 11
	.BYTE	138,134,  2,132,  2,128,234,  0
	.BYTE	 15, 30, 60, 58, 58, 26, 11,  1
	.BYTE	  0,124,254,240,254, 98,124,  0
	.BYTE	126,  0,170, 85,170, 85,170, 85
	.BYTE	  0, 62,127, 15,127, 70, 62,  0
	.BYTE	240,120, 60, 92, 92, 88,208,128
	.BYTE	 69, 67,  1, 66,  1, 64,117,  0
	.BYTE	190, 30,174, 22,142, 22,138, 22
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 66,106,114,106,114,122, 82,106
	.BYTE	170, 85,  0,189,165,189,  0,255
	.BYTE	 66,106, 82,106, 82,106,114,122
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 95, 15, 87, 11, 71, 11, 69, 11
	.BYTE	138,134,  2,132,  2,128,106,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 82,106, 82,106,114,106,114,122
	.BYTE	255,255,255,247,247,247,247,231
	.BYTE	114,106,114,122,114,106, 82,106
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 69, 67,  1, 66,  1, 64,117,  0
	.BYTE	 62, 22, 42, 22, 10,  4,  2, 20
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	114,106,114,122, 82, 42, 82, 34
	.BYTE	231,231,227,227,195,195,  0,195
	.BYTE	 82,106,114,122, 82,106, 82, 34
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 62, 10, 84,  8, 68,  0, 64, 40
	.BYTE	  0,  7,  0,  2,  1,  0,  0,  0
	.BYTE	  0,255,  0,170, 85,  0,  8,  0
	.BYTE	  0,255,  0,170, 85,  0,136,  0
	.BYTE	  0,255,  0,170, 85,  0,136,  0
	.BYTE	  0,255,  0,170, 85,  0,136,  0
	.BYTE	  0,255,  0,170, 85,  0,136,  0
	.BYTE	  0,224,  0,128,  0,  0,  0,  0
	.BYTE	  2,  2,  2,  2,  2,  2,  2, 66
	.BYTE	  5,  5,  5,  5,  5, 66,  2,  0
	.BYTE	  5, 65,  5,  0,  2, 66, 65,  5
	.BYTE	 65,  5, 65, 66,  2, 65, 70, 65
	.BYTE	 70, 65,  2, 66,  0, 69, 65, 69
	.BYTE	  0, 66,  2,  0, 69, 65, 69,  0
	.BYTE	  2,  2,  0, 69, 65, 69,  0,  2
	.BYTE	  3,  3,  3,  3,  3,  3,  3
	
Pointer:
	.BYTE 1,3
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 24, 36, 90,181,169, 82, 36, 24
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  1,  1,  1