PlayPuzzle1

;draw puzzle initial state	
	CALL ClearScreen
	
	LD HL,16384+132
	LD DE,Puzzle1
	CALL DrawTile
	
	LD HL,16384+88
	LD DE,Puzzle1_Hint
	CALL DrawTile
	
	LD HL,18432+120
	LD DE,LeverText
	CALL TypeText
	
	LD HL,20480+56
	LD DE,MovesText
	CALL TypeText
	
	
	LD HL,16384+22
	LD BC,9*256+24
	CALL DrawBorder
	
	LD A,99
	LD (MovesPuzzle1),A
	CALL DisplayMoves_Puzzle1
	
	LD HL,90*256+121		;moves number attribute
	LD A,69
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A
	
	
;copy balls map from initial position
	LD HL,Puzzle1Start
	LD DE,Puzzle1Game
	LD BC,35
	LDIR	
	
	CALL DrawBalls_Start
	
	LD A,1
	LD (SelectedBall),A
	CALL DrawSelectedBall
	CALL ChangeBall2
		
	
PlayPuzzle1_Loop
	HALT
	CALL CheckPuzzle1Win
	CALL CheckPuzzle1Lose
	
	CALL CheckQuit
	CALL GetPlayerInput
	
;control	
	BIT 0,A
	JP NZ,ControlBallRight
	BIT 1,A
	JP NZ,ControlBallLeft
	BIT 2,A
	JP NZ,ControlBallDown
	BIT 3,A
	JP NZ,ControlBallUp
	
	BIT 4,A
	CALL NZ,ChangeBall
	JR PlayPuzzle1_Loop
	
	RET
	
SelectedBall			.BYTE 1	
SelectedBallPos			.BYTE 0		;single byte ball position in the map
SelectedBallRow			.BYTE 0		;x,y coordinates in the puzzle map
SelectedBallCol			.BYTE 0

;-------------	
SelectedBallX				.BYTE 0 ;screen coordinates
SelectedBallY				.BYTE 0
BallColor					.BYTE 4	

;------------
ControlBallLeft
;check if movement possible
	CALL FindSelectedBall	;update coordinates
	LD A,(SelectedBallPos)	
	LD HL,Puzzle1Game
	LD E,A
	LD D,0
	ADD HL,DE				;find ball position in table
	
	DEC HL					;one square left
	LD A,(HL)
	OR A					;is this square empty
	JP NZ,PlayPuzzle1_Loop	;no, movement not possible

	PUSH HL
	CALL MoveBallLeft		;move ball on screen
	POP HL
	
	LD A,(SelectedBall)		;change map position
	LD (HL),A				;write at new position
	INC HL
	XOR A
	LD (HL),A				;clear at old position
	
		
	JP PlayPuzzle1_Loop
	
;------------
ControlBallRight
;check if movement possible
	CALL FindSelectedBall	;update coordinates
	LD A,(SelectedBallPos)	
	LD HL,Puzzle1Game
	LD E,A
	LD D,0
	ADD HL,DE				;find ball position in table
	INC HL					;one square right
	LD A,(HL)
	OR A					;is this square empty
	JP NZ,PlayPuzzle1_Loop	;no, movement not possible

	PUSH HL
	CALL MoveBallRight		;move ball on screen
	POP HL
	
	LD A,(SelectedBall)		;change map position
	LD (HL),A				;write at new position
	DEC HL
	XOR A
	LD (HL),A				;clear at old position
	CALL FindSelectedBall	;update coordinates
	JP PlayPuzzle1_Loop
	
;------------
ControlBallUp
;check if movement possible
	CALL FindSelectedBall	;update coordinates
	LD A,(SelectedBallPos)	
	LD HL,Puzzle1Game
	LD E,A
	LD D,0
	ADD HL,DE				;find ball position in table
	LD DE,5
	
	SBC HL,DE				;one square up
	LD A,(HL)
	OR A					;is this square empty
	JP NZ,PlayPuzzle1_Loop	;no, movement not possible

	LD A,(SelectedBall)		;change map position
	LD (HL),A				;write at new position
	ADC HL,DE
	XOR A
	LD (HL),A				;clear at old position
	
	
	CALL MoveBallUp			;move ball on screen
	JP PlayPuzzle1_Loop

;------------
ControlBallDown
;check if movement possible
	CALL FindSelectedBall	;update coordinates
	LD A,(SelectedBallPos)	
	LD HL,Puzzle1Game
	LD E,A
	LD D,0
	ADD HL,DE				;find ball position in table
	LD DE,5
	
	ADD HL,DE				;one square down
	LD A,(HL)
	OR A					;is this square empty
	JP NZ,PlayPuzzle1_Loop	;no, movement not possible

	LD A,(SelectedBall)		;change map position
	LD (HL),A				;write at new position
	SBC HL,DE
	XOR A
	LD (HL),A				;clear at old position

	CALL MoveBallDown			;move ball on screen
	JP PlayPuzzle1_Loop



;-----------------------------
ChangeBall
	LD A,(SelectedBall)
	INC A
	CP 7					;there are six balls
	JR NZ,ChangeBall2
	LD A,1
	
ChangeBall2
	LD (SelectedBall),A
	CALL DrawSelectedBall
	CALL Sound1
	CALL FindSelectedBall
	CALL FlashBall
	
	RET
	
;-------------	
DrawSelectedBall	
	LD A,(SelectedBall)
	LD (BallColor),A
	LD BC,204*256+100
	CALL DrawBall
	RET

;-------------
FindSelectedBall
	LD A,(SelectedBall)
	LD HL,Puzzle1Game
	LD B,0
	
FindSelectedBall2
	CP (HL)				
	JR Z,FindSelectedBall3	;ball number found in the table
	INC HL
	INC B					;go to next table position
	JR FindSelectedBall2

FindSelectedBall3
;B points to table position, but we need x and y of 2-dimensional table
	LD A,B
	LD (SelectedBallPos),A	;store single byte position for later use
	
	LD B,0
FindSelectedBall4
	INC B					;find row
	SUB 5
	JR NC,FindSelectedBall4
	
	DEC B					;loop did one INC B too many
	ADD A,5
	LD C,A					;B-row,C-collumn
	
	LD (SelectedBallCol),A
	LD A,B
	LD (SelectedBallRow),A
	
	CALL FindBallXY
	
	LD A,(SelectedBallX)
	LD B,A
	LD A,(SelectedBallY)
	LD C,A
	RET
	
;-------------------	
FlashBall
;flashing animation of selected ball
	LD D,9
	LD HL,SelectedBallX
	LD B,(HL)						;position
	INC HL
	LD C,(HL)
	
FlashBall2
	PUSH DE

	HALT
	HALT
	PUSH BC
	LD A,71							;white color
	LD (BallColor),A
	CALL DrawBall
	POP BC
	
	HALT
	HALT
	PUSH BC
	LD A,(SelectedBall)				;original color	r
	LD (BallColor),A
	CALL DrawBall
	POP BC
	
	POP DE
	DEC D
	JR NZ,FlashBall2
	RET
	
;-------------------
FindBallXY
;C-collumn,B-row
		
	LD A,48				;X  of corner of screen area responisble for displaying puzzle map	
FindBallXY_1
	ADD A,16
	DEC C
	JR NZ,FindBallXY_1
	LD (SelectedBallX),A
	
	LD A,32				;Y  of corner of screen area responisble for displaying puzzle map	
FindBallXY_2
	ADD A,16
	DEC B
	JR NZ,FindBallXY_2
	LD (SelectedBallY),A
	RET
	
	

;-----------------------------
DrawBalls_Start
;draw all balls at their initial position
	
	LD BC,48*256+32			;puzzle playing area screen left top corner
	LD HL,Puzzle1Game		;Puzzle data
	
	LD D,7					;puzzle height
	
DrawBalls_Start1
	LD E,5					;puzzle width
	
DrawBalls_Start2
	LD A,(HL)				;read puzzle data
	OR A
	JR Z,DrawBalls_Start3	;empty space, don't draw
	CP 8
	JR Z,DrawBalls_Start3	;filled space, don't draw

	LD (BallColor),A		;draw a ball
	PUSH BC					;number in puzzle data codes its color
	PUSH DE
	PUSH HL
	CALL DrawBall
	POP HL
	POP DE
	POP BC
	
DrawBalls_Start3	
	LD A,B					;change screen position - 16 pixels right
	ADD A,16
	LD B,A	
	
	INC HL					;next puzzle data
	
	DEC E
	JR NZ,DrawBalls_Start2
	
	LD A,B
	SUB 5*16				;go to beginning of ball line on the screen
	LD B,A
	LD A,C
	ADD A,16				;go 16 pixels down to next ball line
	LD C,A
	
	DEC D
	JR NZ,DrawBalls_Start1
	RET
	
;-----------------------------
MoveBallUp
	LD B,16
MoveBallUp2
	PUSH BC
	CALL MoveBallDraw
	
	LD HL,SelectedBallY
	DEC (HL)
	
	POP BC
	DJNZ MoveBallUp2
	CALL MoveBallDraw
	CALL DecreaseMoves_Puzzle1
	RET
	
;-------------
MoveBallDown
	LD B,16
MoveBallDown2
	PUSH BC
	CALL MoveBallDraw
	
	LD HL,SelectedBallY
	INC (HL)
	
	POP BC
	DJNZ MoveBallDown2
	CALL MoveBallDraw
	CALL DecreaseMoves_Puzzle1
	RET

;-------------
MoveBallLeft
	LD B,16
MoveBallLeft2
	PUSH BC
	CALL MoveBallDraw
	
	LD HL,SelectedBallX
	DEC (HL)
	
	POP BC
	DJNZ MoveBallLeft2
	CALL MoveBallDraw
	CALL DecreaseMoves_Puzzle1
	RET
;-------------
MoveBallRight
	LD B,16
MoveBallRight2
	PUSH BC
	CALL MoveBallDraw
	
	LD HL,SelectedBallX
	INC (HL)
	
	POP BC
	DJNZ MoveBallRight2
	CALL MoveBallDraw
	CALL DecreaseMoves_Puzzle1
	RET


;-------------
MoveBallDraw	
	LD HL,SelectedBallX		;get coordinates
	LD B,(HL)
	INC HL
	LD C,(HL)
	
	HALT
	CALL DrawBall
	RET
	

;-------------------------
DrawBall
	;BC - XY position

	PUSH BC	
	CALL XYtoHL 				;read ball HL coordinates
	PUSH HL
	
;determine ball sprite using shift
	LD B,A
	LD HL,Ball0
	LD DE,48
	OR A
	JR Z,DrawBall2				;shift=0,first sprite
DrawBall1
	ADD HL,DE					;find sprite address
	DJNZ DrawBall1

	
DrawBall2
	EX HL,DE					;sprite address in DE
	POP HL						;screen position
	LD B,16
	
	OR A						;check shift
	JR Z,DrawBall31				;other drawing code for ball only 2 bytes wide
	
;drawing ball sprite 3 bytes wide	
DrawBall3	
	LD A,(DE)					;one line of pixels
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	DEC L
	DEC L	
	CALL OnePixelLineDown		;go to next line of pixels
	DJNZ DrawBall3
	JR DrawBall32

;drawing ball sprite 2 bytes wide
DrawBall31
	LD A,(DE)					;one line of pixels
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	DEC L
	INC DE
	CALL OnePixelLineDown		;go to next line of pixels
	DJNZ DrawBall31	
		
	
DrawBall32	
;drawing ball colors
;find ball attribute position
	POP BC 						;restore XY position
	
	EXX
	LD BC,2*256+2				;default ball size (at equal position)
	EXX
		
	LD A,C
	AND 00000111b				;horizontal equal position?
	JR Z,DrawBall4
	
	EXX
	INC C						;draw 3 attribute squars in width if not equal position
	EXX
	
DrawBall4
	LD A,B
	AND 00000111b				;vertical equal position?
	JR Z,DrawBall5
	
	EXX
	INC B						;draw 3 attribute squars in height if not equal position
	EXX
	
DrawBall5
	LD A,C
	AND 11111000b				;remove last 3 "unequal" horizontal bits
	LD E,A
	LD D,0						;DE=C
	LD HL,22528					;start of attribute address
	ADD HL,DE
	ADD HL,DE					;going 8 lines down means going 32 bytes in attributes addresses
	ADD HL,DE					;32=4*8 so 4 repeats of ADD HL,DE
	ADD HL,DE					;proper line of attributes is reached
	
	LD A,B
	
	SRL A						;a=a/8
	SRL A
	SRL A
	ADD A,L						;adjust collumn in line
	LD L,A
	
	PUSH HL
	EXX
	POP HL						;attribute address into alternate registers
	
	LD A,(BallColor)			;color
	LD DE,32
	
DrawBall6
	PUSH BC
	PUSH HL
DrawBall7
;one row of attributes
	LD (HL),A
	INC L
	DJNZ DrawBall7
	
	POP HL						;restore beginning of line
	POP BC						;restore width
	ADD HL,DE					;go one line down
	DEC C
	JR NZ,DrawBall6
	
	EXX
	RET
	
;-------------
CheckPuzzle1Win
	LD DE,Puzzle1Game
	LD HL,Puzzle1Win
	LD B,35						;compare all fields in game map and winning map
	
CheckPuzzle1Win2
	LD A,(DE)
	CP (HL)
	RET NZ						;return if there is a difference - solution not obtained
	INC DE
	INC HL
	DJNZ CheckPuzzle1Win2
	
;winning the puzzle
	CALL Sound2
	CALL FadeOut
	
	LD A,2
	LD (LevelNr),A
	CALL DrawEndOfLevelScreen
	JP StartLevel
	
	
CheckPuzzle1Win3			   ;code never comes here
	JP CheckPuzzle1Win3
	
;----------------
CheckPuzzle1Lose
	LD A,(MovesPuzzle1)
	OR A
	JP Z,GameOver
	RET
	
;-----------------
DecreaseMoves_Puzzle1
	LD A,(MovesPuzzle1)
	DEC A
	LD (MovesPuzzle1),A
	CALL DisplayMoves_Puzzle1
	RET

	
  	
;-------------
Puzzle1Start
	.BYTE 8,8,8,8,8
	.BYTE 8,4,5,6,8
	.BYTE 8,8,0,8,8
	.BYTE 8,0,0,8,8
	.BYTE 8,8,0,8,8
	.BYTE 8,1,2,3,8
	.BYTE 8,8,8,8,8	
	
Puzzle1Game
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	.BYTE 0,0,0,0,0
	
Puzzle1Win
	.BYTE 8,8,8,8,8
	.BYTE 8,1,2,3,8
	.BYTE 8,8,0,8,8
	.BYTE 8,0,0,8,8
	.BYTE 8,8,0,8,8
	.BYTE 8,4,5,6,8
	.BYTE 8,8,8,8,8
