

PlayPuzzle2

 ;draw puzzle initial state	
 ;draw static graphics
	CALL ClearScreen
	
	LD HL,18432
	LD DE,Puzzle2_1
	CALL DrawTile
	
		
	LD HL,18433
	LD B,5
PlayPuzzle2_1
	PUSH HL
	PUSH BC
	LD DE,Puzzle2_2
	CALL DrawTile
	POP BC
	POP HL
	LD A,L
	ADD A,6
	LD L,A
	DJNZ PlayPuzzle2_1
	
	LD HL,18432+31
	LD DE,Puzzle2_3
	CALL DrawTile
	
	LD HL,20480+75
	LD BC,9*256+4
	CALL DrawBorder
	
	LD HL,20480+109
	LD DE,MovesText
	CALL TypeText
	
	LD A,30
	LD (MovesPuzzle2),A
	CALL DisplayMoves_Puzzle2
	
	LD HL,90*256+142	;moves number attribute
	LD A,69
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A
	

;copy initial puzzle data to game data
	LD HL,ItemsTable_Start	
	LD DE,ItemsTable_Game
	LD BC,5
	LDIR
			

	CALL DrawItems_Start
	
	LD A,1
	LD (ChosenItem),A
	CALL MarkSelectedItem
	
PlayPuzzle2_Loop
	CALL CheckPuzzle2Win
	CALL CheckPuzzle2Lose
	
	CALL CheckQuit
	CALL GetPlayerInput
	
;control	
	BIT 0,A
	JP NZ,ChangeButtonsRight
	BIT 1,A
	JP NZ,ChangeButtonsLeft
	
	BIT 4,A
	CALL NZ,RotateItems
	
	JR PlayPuzzle2_Loop

;-------------------
ChangeButtonsLeft
	LD A,(ChosenItem)
	CP 1					;item 1 - no more going left
	JP Z,PlayPuzzle2_Loop
	
;remove hightlight of previous item	
	LD A,(ChItem_ButtonAttrL)
	LD L,A
	LD H,89
	LD A,68
	LD (HL),A
	INC HL
	LD (HL),A
	
	LD HL,ChosenItem
	DEC (HL)				;change item - go one item left
	CALL MarkSelectedItem
	JP PlayPuzzle2_Loop

;-------------------
ChangeButtonsRight
	LD A,(ChosenItem)
	CP 5					;item 1 - no more going left
	JP Z,PlayPuzzle2_Loop
	
;remove hightlight of previous item	
	LD A,(ChItem_ButtonAttrL)
	LD L,A
	LD H,89
	LD A,68
	LD (HL),A
	INC HL
	LD (HL),A
	
	LD HL,ChosenItem
	INC (HL)				;change item - go one item left
	CALL MarkSelectedItem
	JP PlayPuzzle2_Loop
	
;-------------------
CheckPuzzle2Win
	LD DE,ItemsTable_Game
	LD HL,ItemsTable_Win
	LD B,5
CheckPuzzle2Win2
	LD A,(DE)
	CP (HL)
	RET NZ						;return if there is a difference - solution not obtained
	INC DE
	INC HL
	DJNZ CheckPuzzle2Win2
	
;winning the puzzle
	CALL Sound2
	CALL FadeOut
	CALL DrawEndOfLevelScreen
	
	LD A,3
	LD (LevelNr),A
	JP StartLevel
CheckPuzzle2Win3			   ;code never comes here
	JP CheckPuzzle2Win3
	
;------------------
CheckPuzzle2Lose
	LD A,(MovesPuzzle2)
	OR A
	JP Z,GameOver
	RET		
	
;-------------------
DrawItems_Start
	LD HL,18466
	LD B,5
	LD IX,ItemsTable_Game
	
;draw items graphics	
DrawItems_Start2
	PUSH HL
	PUSH BC
	LD A,(IX+0)				;item number
	CALL FindItemAddress	;item address into DE
	CALL DrawItem
	
	POP BC
	POP HL					;restore screen position
	LD A,L
	ADD A,6					;go to next position
	LD L,A
	INC IX
	DJNZ DrawItems_Start2
	
;draw items attributes
	LD B,5
	LD HL,22818
	LD IX,ItemColors_Start
	
DrawItems_Start3	
	LD D,4
	
DrawItems_Start4
	LD A,(IX+0)				;read attribute
	LD E,4
	
DrawItems_Start5			;row of attributes
	LD (HL),A
	INC L
	DEC E
	JR NZ,DrawItems_Start5
	
	LD A,L					;go one attr line down
	ADD A,28
	LD L,A
	DEC D
	JR NZ,DrawItems_Start4
	
	LD A,L
	SBC 122					;go to next item
	LD L,A
	INC IX					;next attribute
	
	DJNZ DrawItems_Start3
	RET
	

;-------------------
DrawItem
;DE address,HL-pos
	LD B,32
	
DrawItem2
;one pixel line
	LD A,(DE)
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	INC L
	LD A,(DE)
	LD (HL),A
	INC DE
	DEC L
	DEC L
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawItem2
	RET
	
;----------------
FindItemAddress
;A - item number
	PUSH HL							;preserve HL
	LD HL,Weights					;first sprite of 4 ones
	LD DE,128						;sprite size
	OR A
	JR Z,FindItemAddress3			;0 means sun sprite
	
	LD B,A
FindItemAddress2
	ADD HL,DE
	DJNZ FindItemAddress2

FindItemAddress3
	EX HL,DE						;item address into DE
	POP HL
	RET

;--------------------------	
MarkSelectedItem
	CALL Sound1
	LD A,(ChosenItem)
	
	LD B,A
	LD A,195-6				;position of first button-6
MarkSelectedItem2
	ADD A,6					;find position of proper buttom
	DJNZ MarkSelectedItem2
	
	LD (ChItem_ButtonAttrL),A
	
;blink selected button
	LD B,7
MarkSelectedItem3
	HALT
	HALT
	LD C,68
	CALL ColorSelectedButton
	
	HALT
	HALT
	LD C,70
	CALL ColorSelectedButton
	
	DJNZ MarkSelectedItem3
	
;change address of current reels rotating pattern	
	LD A,(ChosenItem)
	LD B,A
	LD HL,Button1Pattern-5
	LD DE,5					;one pattern - 5 reels = 5 bytes
	
MarkSelectedItem4
	ADD HL,DE
	DJNZ MarkSelectedItem4
	
	LD (CurrentButtonPattern),HL
	RET
	
ColorSelectedButton
;C-chosen color
	LD A,(ChItem_ButtonAttrL)
	LD L,A	
	LD H,89
	LD (HL),C
	INC L
	LD (HL),C
	RET
	
;--------------------------	
RotateItems
	CALL Sound3
	LD C,66
	CALL ColorSelectedButton

	
	XOR A
	LD (RotateStep),A

RotateItems2
	HALT
	
	LD HL,(CurrentButtonPattern)
	EX HL,DE		
	
	LD B,1
RotateItems3	
	PUSH BC
	PUSH DE
	LD A,(DE)				;which way to rotate reel
	
	OR A
	JR Z,RotateItems5		;0 = don't do anything with reel
	
	CP 255
	JR Z,RotateItems4		;rotate down
	
;rotate reel up
	LD A,B
	CALL RotateItemUp
	JR RotateItems5	
	
;rotate reel down
RotateItems4
	LD A,B
    CALL RotateItemDown
    
    
RotateItems5
	POP DE
	POP BC
	
	INC DE					;go to next reel data
	INC B					;next reel number
	LD A,B
	CP 6
	JR NZ, RotateItems3		;do all 5 reels
	
    LD HL, RotateStep
    INC (HL)
    LD A,(HL)
    CP 40
    JR NZ,RotateItems2
    
    
;change items in table    
    LD B,5				;numbers of reels
	LD HL,(CurrentButtonPattern)
	EX HL,DE
	LD HL,ItemsTable_Game
RotateItems6  
	LD A,(DE)			;read 255 or 1 (add 1 or subtract 1)
	ADD (HL)			;and sum it with current item on reel
	AND 00000011b		;255 becomes 3 as reel rolls over
	LD (HL),A			;write new item to table
	INC DE				
	INC HL				;next reel
	DJNZ RotateItems6
	
	LD C,70				;restore button yellow color
	CALL ColorSelectedButton  
 	
	CALL DecreaseMoves_Puzzle2
		
	RET
	
RotateStep .BYTE 0			;number 0-40 describing how many steps in reels rotating are left to do
	
;----------------------------
;----------------------------
RotateItemUp
;A - number of reel (1-5)
;find screen position of reel
	LD C,A
	LD HL,18466-6
	LD B,A
	
RotateItemUp2
	LD A,L
	ADD A,6					;screen position into HL
	LD L,A
	DJNZ RotateItemUp2
	LD (TopRotateLine),HL
	
	LD A,C
	PUSH AF	
	LD BC,4*256+4
	CALL ScrollUp			;scroll graphics in reel up
	POP AF					;restore reel number
	
	LD HL,ItemsTable_Game-1
	LD E,A
	LD D,0
	ADD HL,DE				;find our reel in table
	
	LD A,(HL)				;current item on reel
	INC A					;go to next item
	AND 00000011b			; numbers from 0 to 3, going up from 0 gives 3
	LD C,A
	LD (NextItemNr),A		;store to be used by attribute routine
		
	LD A,(RotateStep)
	CP 8					;40 steps of scrolling, first 8 steps - don't make a new item to appear
	RET C
	
;draw next line of next item graphics at the bottom line
	LD A,C					;next item number in A
	CALL FindItemAddress	;address of next item graphics into DE
	
	LD A,(RotateStep)
	SUB 8					;step 8-40 gives pixel line 0-32 to copy
	
	EX HL,DE				;graphics into HL
	LD DE,4
	
	OR A
	JR Z,RotateItemUp31		;no need to do loop for the first line of sprite
	
RotateItemUp3				;find address of proper pixel line
	ADD HL,DE
	DEC A
	JR NZ,RotateItemUp3
	
RotateItemUp31
	EX HL,DE				;address of graphics into DE
		
	
	LD HL,(TopRotateLine)
	PUSH DE
	LD DE, 7*256+96			;go to bottom pixel line of scrolling area
	ADD HL,DE
	POP DE					;restore graphics
	
	LD B,4					;four bytes in pixel line
RotateItemUp4
	LD A,(DE)
	LD (HL),A				;copy data
	INC L
	INC DE
	DJNZ RotateItemUp4
	
;adjust attributes	(new item has new attributes)
	
;determine color of next item
;--------
	LD A,(NextItemNr)		
	LD HL,ItemColors
	OR A
	JR Z,RotateItemUp42
	
RotateItemUp41
	INC HL
	DEC A
	JR NZ,RotateItemUp41
RotateItemUp42
	LD C,(HL)					;color into C
;--------

	LD A,(RotateStep)
	SRL A					;A=A/8
	SRL A
	SRL A	
	
	OR A					;don't draw new attributes for first 8 steps of rotating
	RET Z
	LD B,A					;number of attribute rows to be drawn
	
	LD HL,(TopRotateLine)	;find position of bottom row of attributes
	LD H,89					;in scrolled area
	LD A,96					;3 rows down, 3*32
	ADD A,L
	LD L,A

	
RotateItemUp5
	LD (HL),C				;paint one row of attributes
	INC L
	LD (HL),C
	INC L
	LD (HL),C
	INC L
	LD (HL),C
	
	LD A,L
	SUB 35					;go one attribute row up
	LD L,A
	DJNZ RotateItemUp5		;do as many attribute rows as necessary
	
	RET
	
TopRotateLine	.WORD 0	
NextItemNr		.BYTE 0


;----------------------------
;----------------------------
RotateItemDown
;A - number of reel (1-5)
;find screen position of reel
	LD C,A
	LD HL,18466-6
	LD B,A
	
RotateItemDown2
	LD A,L					;adjust position, add number of reels*6 (6=distance between reels)
	ADD A,6					;screen position into HL
	LD L,A
	DJNZ RotateItemDown2
	LD (TopRotateLine),HL
	
	LD A,C
	PUSH AF	
	LD BC,4*256+4
	CALL ScrollDown			;scroll graphics in reel down
	POP AF					;restore reel number
	
	LD HL,ItemsTable_Game-1
	LD E,A
	LD D,0
	ADD HL,DE				;find our reel in table
	
	LD A,(HL)				;current item on reel
	DEC A					;go to next item
	AND 00000011b			; numbers from 0 to 3, going up from 3 gives 0
	LD C,A
	LD (NextItemNr),A		;store to be used by attribute routine
		
	LD A,(RotateStep)
	CP 8					;40 steps of scrolling, first 8 steps - don't make a new item to appear
	RET C
	
;draw next line of next item graphics at the bottom line
	LD A,C					;next item number in A
	CALL FindItemAddress	;address of next item graphics into DE
	
	LD A,(RotateStep)
	SUB 8					;step 8-40 gives pixel line 0-32 to copy
	
	EX HL,DE				;graphics start into HL
							;but we must not to first pixel line of sprite but last one

	LD DE,31*4
	ADD HL,DE				;bottom pixel line of the sprite							
							
	LD DE,4
	
	OR A
	JR Z,RotateItemDown31		;no need to do loop for the last line of sprite
	
RotateItemDown3				;find address of proper pixel line
	SBC HL,DE				;in 1st step we draw bottom line, then in next step,we go up with lines
	DEC A
	JR NZ,RotateItemDown3
	
RotateItemDown31
	EX HL,DE				;address of graphics into DE
		
	
	LD HL,(TopRotateLine)
		
	LD B,4					;four bytes in pixel line
RotateItemDown4
	LD A,(DE)
	LD (HL),A				;copy data
	INC L
	INC DE
	DJNZ RotateItemDown4
	
;adjust attributes	(new item has new attributes)
	
;determine color of next item
;--------
	LD A,(NextItemNr)		
	LD HL,ItemColors
	OR A
	JR Z,RotateItemDown42
	
RotateItemDown41
	INC HL
	DEC A
	JR NZ,RotateItemDown41
RotateItemDown42
	LD C,(HL)					;color into C
;--------

	LD A,(RotateStep)
	SRL A					;A=A/8
	SRL A
	SRL A	
	
	OR A					;don't draw new attributes for first 8 steps of rotating
	RET Z
	LD B,A					;number of attribute rows to be drawn
	
	LD HL,(TopRotateLine)	;find position of top row of attributes
	LD H,89					;in scrolled area
	
	
RotateItemDown5
	LD (HL),C				;paint one row of attributes
	INC L
	LD (HL),C
	INC L
	LD (HL),C
	INC L
	LD (HL),C
	
	LD A,L
	ADD A,29					;go one attribute row down
	LD L,A
	DJNZ RotateItemDown5		;do as many attribute rows as necessary
	
	RET
	
	
		

;--------------------------	
ScrollUp
;move the graphics in descried collumns one pixel up
;graphics which reach top of scrolling area dissapear
;hl: screen address, b:width in bytes, c:height in character lines
	
	LD D,H
	LD E,L			;DE=HL
	
	INC D			;de points to next pixel, one line lower than HL

ScrollUp2		
	PUSH BC			;store scrolling area
	
;do one character line	
	LD C,7			;repeat 7 times
	
ScrollUp3	
	PUSH BC
	LD C,L			;store first byte in the line screen position
ScrollUp4
	LD A,(DE)		;read lower byte	
	LD (HL),A		;and write it one line higher
	INC L
	INC E			;next byte in a line
	DJNZ ScrollUp4	;do one pixel line
	
	LD L,C			;restore  position of first byte in the line
	LD E,C
	
	INC H			;go one line down
	INC D
	
	POP BC			;restore number of repeats
	DEC C
	JR NZ,ScrollUp3
	

	
	LD A,E			;the last pixel line in character line is different
	ADD A,32		;because whe read the line below it from next character
	LD E,A			;go one character line down
	
	LD C,E			;store first byte in the line screen position
	
	JR C,ScrollUp5	;next segment?
	LD A,D
	SUB 8
	LD D,A

ScrollUp5			;copy last pixel line in character line
	LD A,(DE)		
	LD (HL),A		
	INC L
	INC E			
	DJNZ ScrollUp5
	
	LD E,C			;restore first byte in the new character line screen position	
	LD L,E			;HL becomes DE
	LD H,D
	INC D			;D goes one line lower
	
	POP BC			;restore scrolling area
	DEC C			;number of character lines left to do
	JR NZ,ScrollUp2
	
	RET	
	
	
;--------------------------	
ScrollDown
;move the graphics in descried collumns one pixel Down
;graphics which reach top of scrolling area dissapear
;hl: screen address, b:width in bytes, c:height in character lines
	
;find the last bottom pixel line of scrolling area
	PUSH BC
	
	DEC C			;adjust C
ScrollDown11
	LD A,L
	ADD A,32			;one char line down
	LD L,A
	JR NC,ScrollDown12
	LD A,H
	ADD A,8				;next screen segment if necessary
	LD H,A
ScrollDown12
	DEC C				;c - number of char lines
	JR NZ,ScrollDown11
	
	LD A,H			;go to 7th,last pixel line in a char
	ADD A,7
	LD H,A	
	
	POP BC
	LD D,H
	LD E,L			;DE=HL
	
	DEC D			;de points to next pixel, one upper lower than HL

ScrollDown2		
	PUSH BC			;store scrolling area
	
;do one character line	
	LD C,7			;repeat 7 times
	
ScrollDown3	
	PUSH BC
	LD C,L			;store first byte in the line screen position
ScrollDown4
	LD A,(DE)		;read upper byte	
	LD (HL),A		;and write it one line lower
	INC L
	INC E			;next byte in a line
	DJNZ ScrollDown4	;do one pixel line
	
	LD L,C			;restore  position of first byte in the line
	LD E,C
	
	DEC H			;go one line up
	DEC D
	
	POP BC			;restore number of repeats
	DEC C
	JR NZ,ScrollDown3
	

	
	LD A,E			;the last pixel line in character line is different
	SUB 32			;because whe read the line over it, from next character line
	LD E,A			;go one character line up
	
	LD C,E			;store first byte in the line screen position
	
	JR C,ScrollDown5	;next segment?
	LD A,D
	ADD A,8
	LD D,A

ScrollDown5			;copy last pixel line in character line
	LD A,(DE)		
	LD (HL),A		
	INC L
	INC E			
	DJNZ ScrollDown5
	
	LD E,C			;restore first byte in the new character line screen position	
	LD L,E			;HL becomes DE
	LD H,D
	DEC D			;D goes one line up
	
	POP BC			;restore scrolling area
	DEC C			;number of character lines left to do
	JR NZ,ScrollDown2
	
	RET	
	
;----------
DecreaseMoves_Puzzle2
	LD A,(MovesPuzzle2)
	DEC A
	LD (MovesPuzzle2),A
	CALL DisplayMoves_Puzzle2
	RET


;-----------------------------

;solution BBDDDEEE

ChosenItem	 		.BYTE 1				;which item, 1,2,3,4, or 5
ChItem_ButtonAttrL  .BYTE 0

	
ItemsTable_Start .BYTE 3,1,2,1,3
ItemsTable_Game  .BYTE 0,0,0,0,0
ItemsTable_Win   .BYTE 2,2,2,2,2

ItemColors_Start .BYTE 112+3,112+1,112+2,112+1,112+3 ;used to draw items for the first time

ItemColors .BYTE 112+0,112+1,112+2,112+3


Button1Pattern						;how items on reels change after pressing button1, button 2, etc.
 .BYTE 255,0,1,0,0				;scrolling down- decrease item number, coded by 255
									;scrolling up- increase item number, coded by 1
									;0 - no change
Button2Pattern	
 .BYTE 	0,255,0,0,1				
 
Button3Pattern			
 .BYTE 0,1,255,1,0					
 
Button4Pattern						
 .BYTE 0,1,0,255,0					

Button5Pattern
 .BYTE 1,0,0,0,255

CurrentButtonPattern	.WORD 0