
;-----------------
BarTopLength_Start
	.BYTE 7,8,5,5,7,8,8,7,8
	
BarBottomLength_Start
	.BYTE 7,4,0,6,7,0,5,4,0
	
BarAttr
	.BYTE 7,7,7,6,6,6,4,4,4
	
	
;normal poistion of bars (when they aren't forced into another poisiotn by another bar)	
BarTipPositions_Free							;Y coordinate of bar tips
	.BYTE 64,72,48,48,64,72,72,64,72			;top line

	.BYTE 80,104,120,88,80,120,96,104,120		;bottom line
												;non existing bar have dummy position 120, lie if they were pushed
						
		
;current positions in the game										
BarTipPositions
	REPT 18
	.BYTE 0
	ENDR
			
	
StuckTable
;is the bar stuck, 0-no,255-yes
	REPT 18
	.BYTE 0
	ENDR					
	
						
												
;--------------------
MoveBarUp
	;move bar two pixels up
	;C -bar number
	
	CALL FindBarTableAddress	;position of bar tip Y into HL
	
	DEC (HL)			;go up
	DEC (HL)
	
	XOR A
	OUT (254),A
	LD B,8
MoveBarUp2
	DJNZ MoveBarUp2	
	LD A,16
	OUT (254),A
	
	LD A,C				;draw bar at new position
	CALL DrawBarEnd
	RET
	
;------------------	
MoveBarDown
	;move bar two pixels down
	;C -bar number
	CALL FindBarTableAddress	;position of bar tip Y into HL
	
	INC (HL)			;go up
	INC (HL)
	
	XOR A
	OUT (254),A
	LD B,8
MoveBarDown2
	DJNZ MoveBarDown2	
	LD A,16
	OUT (254),A
	
	LD A,C				;draw bar at new position
	CALL DrawBarEnd
	RET	
	
;-------------------------------
DrawBarEnd
;A-number of the bar
	CALL FindBarHL
	
;find graphics
	LD A,D
	CP 10
	JR NC,DrawBarEnd6
	CP 3
	JR Z,DrawBarEnd5
	CP 6
	JR Z,DrawBarEnd5
	CP 9
	JR Z,DrawBarEnd5
		
	LD DE,BarEnd1
	JR  DrawBarEnd7		;graphics for bars 1,2,4,5,6,7 			
	
DrawBarEnd5
	LD DE,BarEnd2		;graphics for bars 3,6,9
	JR DrawBarEnd7
	
DrawBarEnd6				
	LD DE,BarEnd3		;graphics for bars 10-19
		
;draw bar end
DrawBarEnd7
	LD B,8
DrawBarEnd8
	LD A,(DE)		;drawing tip of moving bar
	LD (HL),A		;2 bytes in pixel line
	INC DE			;next data bata
	INC L			;go right
	
	LD A,(DE)
	LD (HL),A
	INC DE
	DEC L			;return left
	CALL OnePixelLineDown
	DJNZ DrawBarEnd8
	RET	
	
	
	
;---------------------
FindBarTableAddress
	PUSH BC
	LD HL,BarTipPositions-1	;table of bar tips positions

FindBarTableAddress2
	INC HL
	DEC C				;find bar Y position in table
	JR NZ, FindBarTableAddress2
	POP BC
	RET

;---------------------
FindBarHL
;find HL position of tip of the bar
	;A-number of bar
	
;find bar X position
	LD D,A				;store A
	CP 10				;bars 1-9 are in top position
	JR C,FindBarHL2	;bars 10-19 are in bottom position
						;bar 10 has the same X pos as bar 1, 11 as 2 and os on
	SUB 9				;adjust for bars 10-19
						
FindBarHL2
	LD B,A
	LD A,64-16			;64 - postion of bar 1
FindBarHL3
	ADD A,16			;go to next bar position
	DJNZ FindBarHL3
	LD B,A				;x position into B
	
;find bar Y position
	LD C,D	
	CALL FindBarTableAddress
	LD C,(HL)
	
	CALL XYtoHL			;HL - bar end position
	RET
	
;-------------------------------
;----------------
MoveOtherBars
;when bar is pushed it moves other bar
	LD A,255
	LD (Stucking),A				;when movemnt of other bars is blocked at the shortest length, it will get stuck

	LD A,(BarNumber)			;number of bar which triggered the reaction
;check for special bars
	CP 3
	JP Z,StuckWhiteBars	
	CP 6
	JP Z,StuckYellowBars	
	CP 9
	JP Z,StuckGreenBars	
	
	

;find data which bar is triggered by our bar
	LD HL,MoveBar_Table -2
	LD B,A
MoveOtherBars2
	INC HL						;one bar data is 2 bytes
	INC HL
	DJNZ MoveOtherBars2

;data of proper bar are reached now
	LD C,(HL)					;number of triggered bar to be moved
	INC HL
	LD B,(HL)					;new bar position
	
;find old position of the moved bar
	PUSH BC
	LD DE,BarTipPositions-1	;table of bar tips positions
MoveOtherBars5
	INC DE
	DEC C				;find bar Y position in table
	JR NZ, MoveOtherBars5
	
	POP BC
	LD A,(DE)				;old position in DE
	CP B					;compare to new position, going up or down?
	
	JP Z,PlayPuzzle3_Loop	;equal old and new position, don't move at all (TEMP?)
	JR NC,MoveOtherBars5_Up
	JR C,MoveOtherBars5_Down
	
MoveOtherBars5_Up
	SUB B					;to count movement in pixels 
	LD B,A						
	CALL MoveOtherBarUp
	JP PlayPuzzle3_Loop


MoveOtherBars5_Down
	LD D,A					;subtract old position (smaller value) from new position
	LD A,B
	SUB D
	LD B,A
	CALL MoveOtherBarDown
	JP PlayPuzzle3_Loop
	
	
	
;-----
MoveOtherBarUp
;C - bar number
;B-movement in pixels but we move by chars in loop so divide by 8	
	SRL B
	SRL B
	SRL B
	
	CALL SetBarUnstuck		;triggered bar, if it was blocked will become unblocked
	
	JP CheckBottomBarStuck	;check if lockpick is blocking the bar which we try to move
							;if yes, stuck this bar and finish (RET executed)
							; if no, JP MoveOtherBarUp2
	
MoveOtherBarUp2
	CALL SetBarUnstuck		;triggered bar, if it was blocked will become unblocked


	LD A,C					;bottom bars 10-18 need painting attribute above them to	
	CP 10					;their color before moving
	JR C,MoveOtherBarUp3	;and top bars 1-9 don't need it
	
;test for bottom bar (and only bottom bar) if it tries to push lockpick out
	PUSH BC
	CALL BarGoingUp_PushLockpick	
	POP BC
	
;painting attribute over bottom bar	
	CALL FindBarAttrAddress
	LD DE,32
	SUB HL,DE				;one attribute line up
	CALL FindBarColour
	LD (HL),A				;paint attribute over bar
	INC L
	LD (HL),A

MoveOtherBarUp3	
	REPT 4					;one char = 4 x 2 pixles
	PUSH BC
	HALT
	CALL MoveBarUp			;move graphics
	POP BC
	ENDR

	LD A,C					;top bars 1-9 need painting attribute below them to	
	CP 10					;"empty" background color after moving
	JR NC,MoveOtherBarUp4	;and bottom bars 10-18 don't need it
	
;painting attribute below top bar	
	CALL FindBarAttrAddress
	LD A,69					;background colour
	LD DE,32
	ADD HL,DE				;one attribute line down
	LD (HL),A				;paint attribute
	INC L
	LD (HL),A

MoveOtherBarUp4
	DJNZ MoveOtherBarUp2
	RET
	
;-----
MoveOtherBarDown
;C - bar number
;B-movement in pixels but we move by chars in loop so divide by 8	
	SRL B
	SRL B
	SRL B

	CALL SetBarUnstuck		;triggered bar, if it was blocked will become unblocked
	
	JP CheckTopBarStuck		;check if lockpick is blocking the bar which we try to move
							;if yes, stuck this bar and finsish bar moving (RET executed)
							; if no, JP MoveOtherBarUp2

MoveOtherBarDown2
	LD A,C					;top bars 1-9 need painting attribute below them to	
	CP 10					;their color before moving
	JR NC,MoveOtherBarDown3	;and bottom bars 10-18 don't need it
	
;test for top bar (and only top bar) if it tries to push lockpick out
	PUSH BC
	CALL BarGoingDown_PushLockpick	
	POP BC
		
;painting attribute below top bar	
	CALL FindBarAttrAddress
	LD DE,32
	ADD HL,DE				;one attribute line down
	CALL FindBarColour
	LD (HL),A				;paint attribute over bar
	INC L
	LD (HL),A


MoveOtherBarDown3	
	REPT 4					;one char = 4 x 2 pixles
	PUSH BC
	HALT
	CALL MoveBarDown		;move graphics
	POP BC
	ENDR

	LD A,C					;bottom bars 10-18 need painting attribute above them to	
	CP 10					;"empty" background color after moving
	JR C,MoveOtherBarDown4	;and top bars 1-9 don't need it
	
;painting attribute above bottom bar	
	CALL FindBarAttrAddress
	LD A,69					;background colour
	LD DE,32
	SUB HL,DE				;one attribute line up
	LD (HL),A				;paint attribute
	INC L
	LD (HL),A

MoveOtherBarDown4
	DJNZ MoveOtherBarDown2
	RET
	
;------------
FindBarAttrAddress
;c - bar number	
	PUSH BC
	LD A,C					;bar number
	CALL FindBarHL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A					;attribute address of bar tip
	POP BC
	RET

;-----
FindBarColour
;C - bar number	
	LD A,C
	CP 10
	JR C,FindBarColour2
	SUB 9					;color of bar 10 the same as bar 1
	
FindBarColour2
	LD DE,BarAttr-1
FindBarColour3
	INC DE
	DEC A
	JR NZ,FindBarColour3
	LD A,(DE)			;color into A
	RET
	

	
;--------------
Stucking .BYTE 0			;does the bar will get stuck if it tries to move but gets blocked 0-no,255,yes
	
;--------------
MoveBar_Table
	.BYTE 10,64				;1! pushing 1st bar makes 10th bar to move, so the head of 10th bar takes Y position 64
	.BYTE 10,56				;2!
	.BYTE 0,0				;3 - special
	.BYTE 17,72				;4!
	.BYTE 14,96				;5!
	.BYTE 0,0				;6 - special
	.BYTE 16,96				;7!
	.BYTE 9,88				;8
	.BYTE 0,0				;9 - special
	.BYTE 1,88				;10!
	.BYTE 1,80				;11!
	.BYTE 0,0				;12 not exist
	.BYTE 4,88				;13!
	.BYTE 7,88				;14
	.BYTE 0,0				;15 not exist
	.BYTE 13,96				;16!
	.BYTE 8,88				;17 ZNALEZC !
	.BYTE 0,0				;18 not exist
									
					


;------------------
CheckTopBarStuck
;C bar number
	PUSH BC
	LD A,C
	CALL FindBarHL
	POP BC
	
;is bar at the highest position possible?	
	LD A,H
	CP 64
	JP NZ,MoveOtherBarDown2	;no, move the bar up
	LD A,L
	AND 11100000b
	CP 96					;L  for lowest ar position is from 96 to 127
							;let's extract 32,64,...,224
	JP NZ,MoveOtherBarDown2

;yes it is at the highest position
;now check if second (currently unchosen)lockpick head is just below the bar
	LD A,L					;bar L
	ADD A,32
	LD E,A					;L for the square below the bar
	
	LD HL,(UnchosenLockpickY_Addr)
	PUSH BC
	CALL GetHeadHL2
	POP BC
	
	LD A,H
	CP 64
	JP NZ,MoveOtherBarDown2	;lockpick in different screen segment, so bar for sure can move
	LD A,L
	CP E
	JR Z,CheckTopBarStuck2 ;lockpick exactly above the bar, block the bar
	
	JP MoveOtherBarDown2		;no head, not blocking the bar so don't stuck the bar
	
CheckTopBarStuck2
	LD A,(Stucking)				;if this variable is 0, the bar will not move but won't get stuck
	OR A						;useful when bar is not triggered but tries to return to normal position
	RET Z						;when other bar was released

;make the bar stuck
	CALL SetBarStuck
	CALL Sound3
	RET



;------------------
CheckBottomBarStuck
;C bar number
	PUSH BC
	LD A,C
	CALL FindBarHL
	POP BC
	
;is bar at the lowest position possible?	
	LD A,H
	CP 72
	JP NZ,MoveOtherBarUp2	;no, move the bar up
	LD A,L
	AND 11100000b
	CP 224					;L  for lowest ar position is from 224 to 255
							;let's extract 32,64,...,224
	JP NZ,MoveOtherBarUp2

;yes it is at the lowest position
;now check if second (currently unchosen)lockpick head is just above the bar
	LD A,L					;bar L
	SUB 32
	LD E,A					;L for the square above the bar
	
	LD HL,(UnchosenLockpickY_Addr)
	PUSH BC
	CALL GetHeadHL2
	POP BC
	
	LD A,H
	CP 72
	JP NZ,MoveOtherBarUp2	;lockpick in different screen segment, so bar for sure can move
	LD A,L
	CP E
	JR Z,CheckBottomBarStuck2 ;lockpick exactly above the bar, block the bar
	
	JP MoveOtherBarUp2		;no head, not blocking the bar so don't stuck the bar
	
CheckBottomBarStuck2
	LD A,(Stucking)				;if this variable is 0, the bar will not move but won't get stuck
	OR A						;useful when bar is not triggered but tries to return to normal position
	RET Z						;when other bar was released

;make the bar stuck
	CALL SetBarStuck
	CALL Sound3
	RET
	
		
;-------------
SetBarStuck
;C-bar number
	
	PUSH BC
	LD A,C
	CALL FindBarHL
	POP BC

;make bar head inactive - paint it with navy attribute
 LD A,C
 CP 10
 JR NC,SetBarStuck3

SetBarStuck2
;top bar, go above lockpick
	LD D,1		;navy colour
	CALL ChangeBarAttr_StuckTop
	JR SetBarStuck4

SetBarStuck3
;bottom bar, go below lockpick nad paint 2 rows of attributes
	LD D,1		;navy colour
	CALL ChangeBarAttr_StuckBottom

SetBarStuck4
	LD D,255
	JP ChangeBarStuck


		
;---------------
SetBarUnstuck
;C-bar number
 PUSH BC
 LD A,C
 CALL FindBarHL
 POP BC

 
 LD A,C
 CP 10
 JR NC,SetBarUnstuck3

SetBarUnstuck2
;top bar, go above lockpick
	PUSH HL
	CALL FindBarColour
	POP HL
	LD D,A		;colour into A
	CALL ChangeBarAttr_StuckTop
	JR SetBarUnstuck4

SetBarUnstuck3
;bottom bar, go below lockpick nad paint 2 rows of attributes
	PUSH HL
	CALL FindBarColour
	POP HL
	LD D,A		;colour into A
	CALL ChangeBarAttr_StuckBottom

SetBarUnstuck4
	LD D,0
	JP ChangeBarStuck
	
	
;-------------
ChangeBarAttr_StuckTop
;HL-bar head,D-colour	
	LD A,80		;transform to attributes
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	
	LD (HL),D
	INC L
	LD (HL),D
	PUSH DE
	LD DE,33
	SUB HL,DE	;one attr line up
	POP DE
	LD (HL),D
	INC L
	LD (HL),D
	RET	
	
ChangeBarAttr_StuckBottom
;HL-bar head,D-colour	
	LD A,80		;transform to attributes
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A

	LD (HL),D
	INC L
	LD (HL),D
	PUSH DE		;one attr line down
	LD DE,31
	ADD HL,DE
	POP DE
	LD (HL),D
	INC L
	LD (HL),D
	RET
	
;---------------
ChangeBarStuck
;D: 0=not stuck , 255=stuck

	PUSH BC
	LD HL,StuckTable-1
ChangeBarStuck2
	INC HL
	DEC C
	JR NZ,ChangeBarStuck2
	LD (HL),D			;set stuck or unstuck depending on value of D
	POP BC
	RET
	

;------------------------------------
BarGoingUp_PushLockpick
;c - bar number
;test chosen lockpick
	PUSH BC
	CALL BarGoingUp_PushLockpick1
	POP BC
	
;test unchosen lockpick
	PUSH BC
	CALL ChangeLockpicksTemp				;temporarily swap lockpicks
	POP BC
	CALL BarGoingUp_PushLockpick1
	CALL ChangeLockpicksTemp				;undo swap
	RET
;-----------
BarGoingUp_PushLockpick1
;c - bar number (only bars 10-18)	
	LD A,C
	CALL FindBarHL			;find HL coordinates but also places in BC XY coordinates
;test lockpick	
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)								;get lockpick Y
	ADD A, 8								;adjust number
	CP C									;compare bar tip Y position and lockpick Y position
	RET NZ									;lockpick in safe distance from bar tip
;lockpick Y just above the bar tip Y
;is it short (bar may pass freely) or long (bar pushes out lockpick)?	
	SRL B
	SRL B
	SRL B									; B-bar X coordinate, now B=0..32
	
	INC HL
	INC HL
	LD A,(HL)								;get lockpick length 8 - bar 1, 10 bar 2...
	CP B									;B=lockpick_length when lockpick head just above the bar
	RET C									;lockpick too short to be pushed out
	
	JR TakeLockpickBack
	
;------------------------------------	
BarGoingDown_PushLockpick
;test chosen lockpick
	PUSH BC
	CALL BarGoingDown_PushLockpick1
	POP BC
	
;test unchosen lockpick
	PUSH BC
	CALL ChangeLockpicksTemp				;temporarily swap lockpicks
	POP BC
	CALL BarGoingDown_PushLockpick1
	CALL ChangeLockpicksTemp				;undo swap
	RET
;-----------
BarGoingDown_PushLockpick1
;c - bar number (only bars 1-9)
	LD A,C
	CALL FindBarHL			;find HL coordinates but also places in BC XY coordinates
	
;test lockpick	
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)								;get lockpick Y
	SUB 8									;adjust number
	CP C									;compare bar tip Y position and lockpick Y position
	RET NZ									;lockpick in safe distance from bar tip
	
;lockpick Y just below the bar tip Y
;is it short (bar may pass freely) or long (bar pushes out lockpick)?	
	SRL B
	SRL B
	SRL B									; B-bar X coordinate, now B=0..32
	
	INC HL
	INC HL
	LD A,(HL)								;get lockpick length 8 - bar 1, 10 bar 2...
	CP B									;B=lockpick_length when lockpick head just below the bar

	RET C									;lockpick too short to be pushed out
	JR TakeLockpickBack
	
;--------------	
TakeLockpickBack
;pushing out chosen lockpick
;taking lockpick back left
;A - lockpick lenghth, B- (bar_X)/8

;find how many chars  to move lockpick left
	SUB B									;if A=B (lockpick head below bar) we must
	INC A									;move lockpick 2 chars left
	INC A
	LD B,A
BarGoingDown_PushLockpick3
	PUSH BC
	CALL MoveLockpickLeft1					;moves active, chosen lockpick one char left
	POP BC
	DJNZ BarGoingDown_PushLockpick3
;set bars blocked after movement of lockick
	CALL SetBarBlocked

	RET

;--------------
ChangeLockpicksTemp	
	LD A,(ChosenLockpick)
	CPL						;0->255,255->0
	LD (ChosenLockpick),A
	
;swap lockpicks data	
	LD DE,(ChosenLockpickY_Addr)
	LD HL,(UnchosenLockpickY_Addr)
	LD (ChosenLockpickY_Addr),HL
	LD (UnchosenLockpickY_Addr),DE
	
	LD DE,(ChosenLockpickHead)
	LD HL,(UnchosenLockpickHead)
	LD (ChosenLockpickHead),HL
	LD (UnchosenLockpickHead),DE
	
	LD A,(ChosenLockpickBlockBar)
	LD B,A
	LD A,(UnchosenLockpickBlockBar)
	LD (ChosenLockpickBlockBar),A
	LD A,B
	LD (UnchosenLockpickBlockBar),A
	
	RET	
	

;--------------------------
StuckWhiteBars

	LD B,1						;stuck bar nr 1
	CALL StuckTopBar_Master
	LD B,2
	CALL StuckTopBar_Master
	LD B,10
	CALL StuckBottomBar_Master
	LD B,11
	CALL StuckBottomBar_Master

	LD B,3
	CALL StuckTopBar_Master		;stuck master triggering bar as well
	JP PlayPuzzle3_Loop

StuckYellowBars
	LD B,4						;stuck bar nr 1
	CALL StuckTopBar_Master
	LD B,5
	CALL StuckTopBar_Master
	LD B,13
	CALL StuckBottomBar_Master
	LD B,14
	CALL StuckBottomBar_Master

	LD B,6
	CALL StuckTopBar_Master		;stuck master triggering bar as well
	JP PlayPuzzle3_Loop


StuckGreenBars
	LD B,7						;stuck bar nr 1
	CALL StuckTopBar_Master
	LD B,8
	CALL StuckTopBar_Master
	LD B,16
	CALL StuckBottomBar_Master
	LD B,17
	CALL StuckBottomBar_Master

	LD B,9
	CALL StuckTopBar_Master		;stuck master triggering bar as well
	JP PlayPuzzle3_Loop


;--------------
StuckTopBar_Master				
;move up and stuck bar - triggered by master bar
;B-bar number
	LD C,B						;store number into C
	LD HL,BarTipPositions-1		;get current position of bar tip
StuckTopBar_Master2
	INC HL
	DJNZ StuckTopBar_Master2
						
	LD A,(HL)					;read current position
	SUB 24						;subtract top position to get movement length
	OR A
	JR Z,StuckTopBar_Master3	;bar at top position, don't move
	LD B,A						;movement
	
	PUSH BC						;store bar number
	CALL MoveOtherBarUp			;move bar which numer is in C
	POP BC
	
StuckTopBar_Master3
	CALL SetBarStuck			;stuck the bar
	CALL Sound3
	RET

;--------------
StuckBottomBar_Master				
;move up and stuck bar - triggered by master bar
;B-bar number
	LD C,B						;store number into C
	LD HL,BarTipPositions-1		;get current position of bar tip
StuckBottomBar_Master2
	INC HL
	DJNZ StuckBottomBar_Master2
						
	LD A,(HL)					;read current position
	LD B,A
	LD A,120					;lowest poistion of the bar
	SUB B						;subtract current position to get movement length
	OR A
	JR Z,StuckBottomBar_Master3	;bar at top position, don't move
	LD B,A						;movement
	
	PUSH BC						;store bar number
	CALL MoveOtherBarDown		;move bar which numer is in C
	POP BC
	
StuckBottomBar_Master3
	CALL SetBarStuck			;stuck the bar
	CALL Sound3
	RET

	
;-------------------------------------
ReleaseFreeBars
; when lockpick releases a bar it will return to its normal position (if not stuck)
; also a bar triggered by released bar will return to its normal position (if not stuck)	
	XOR A
	LD (Stucking),A				;when bars are released and they are blocked at shortest length
								;they won't get stuck

	LD HL,BarTipPositions
	LD IX,StuckTable
	LD DE,BarTipPositions_Free

;-------
;check top bars	
	LD B,1
ReleaseFreeBars2	
	LD A,(HL)					;get bar position				
	CP 24						;is it at top position?
	JR NZ,ReleaseFreeBars3		;no, it isn't so it won't be released

;bar is at top position
	LD A,(IX+0)					;is it stuck?
	OR A
	JR NZ,ReleaseFreeBars3		;yes, it is stuck so don't release it
	
	LD A,(ChosenLockpickBlockBar)	;is it blocked by chosen lockpick?
	CP B
	JR Z,ReleaseFreeBars3		;yes, skip it
	
	LD A,(UnchosenLockpickBlockBar)	;is it blocked by unchosen lockpick?
	CP B
	JR Z,ReleaseFreeBars3		;yes, skip it
	
;bar is free, unstuck, unblocked so release it and finish bar checking
	JR ReleaseBar6
	
;go to next bar	
ReleaseFreeBars3

	INC HL
	INC IX
	INC DE
	INC B						;do bars 1-9
	LD A,B
	CP 10
	JR NZ,ReleaseFreeBars2	
	
;-------
;check bottom bars	
	LD B,10
ReleaseFreeBars4	
	LD A,(HL)					;get bar position				
	CP 120						;is it at bottom position?
	JR NZ,ReleaseFreeBars5		;no, it isn't so it won't be released
	
;don't check unexisting bars
	LD A,B
	CP 12
	JR Z,ReleaseFreeBars5
	CP 15
	JR Z,ReleaseFreeBars5
	CP 18
	JR Z,ReleaseFreeBars5

;bar is at bottom position
	LD A,(IX+0)					;is it stuck?
	OR A
	JR NZ,ReleaseFreeBars5		;yes, it is stuck so don't release it
	
	LD A,(ChosenLockpickBlockBar)	;is it blocked by chosen lockpick?
	CP B
	JR Z,ReleaseFreeBars5		;yes, skip it
	
	LD A,(UnchosenLockpickBlockBar)	;is it blocked by unchosen lockpick?
	CP B
	JR Z,ReleaseFreeBars5		;yes, skip it
	
;bar is free, unstuck, unblocked so release it
	JR ReleaseBar6
	
ReleaseFreeBars5
;go to next bar
	INC HL
	INC IX
	INC DE
	
	INC B						;do bars 10-19
	LD A,B
	CP 19
	JR NZ,ReleaseFreeBars4
	RET							;if we reach tis code  -> no bars were released

;------------------
ReleaseBar6
;release bar nr B and bar triggered by it

;first release triggered bar
	LD C,B	
	PUSH BC						;store data of original bar					
	PUSH HL
	PUSH DE
	
;find data which bar is triggered by our bar
	LD HL,MoveBar_Table -2
	
;B is already pointed to original bar nr	
ReleaseBar7
	INC HL						;one bar data is 2 bytes
	INC HL
	DJNZ ReleaseBar7
	LD C,(HL)					;get triggered bar number
	
;check if triggered bar is stuck, if yes -> don't release it
	LD HL,StuckTable-1
	LD A,C
ReleaseBar71
	INC HL
	DEC A
	JR NZ,ReleaseBar71
	LD A,(HL)
	OR A
	JR NZ,ReleaseBar9			;triggered bar is stuck, don't move it
	
	
;find positions for this bar
	LD DE,BarTipPositions_Free-1
	LD HL,BarTipPositions-1
	LD A,C
ReleaseBar8
	INC DE
	INC HL
	DEC A
	JR NZ,ReleaseBar8

	CALL ReleaseBar_Final		;release triggered bar
	
	
ReleaseBar9
	POP DE						;restore data of original bar
	POP HL
	POP BC
	
	CALL ReleaseBar_Final		;release original bar
	
	RET
	

;-------------
ReleaseBar_Final
	LD A,(DE)					;get free position of bar nr C
	LD D,A
	LD A,(HL)					;get current position of bar nr C
	
	CP D						;compare positions
	RET Z						;equal positions - no movement
	JR NC,ReleaseBar_GoUp		;current position bigger = lower than free position ->going up
	JR ReleaseBar_GoDown		;else going down
	RET
	
ReleaseBar_GoUp
;count movement
	SUB D						;subtract free position (smaller) form current (bigger
	LD B,A
	CALL MoveOtherBarUp			;move bar
	RET

ReleaseBar_GoDown
;count movement
	LD E,A
	LD A,D
	SUB E						;subtract current position (smaller) from free (bigger)
	LD B,A
	CALL MoveOtherBarDown
	RET


