
PlayPuzzle3
	CALL ClearScreen
	CALL ClearScreenBlue

	
;drawing the puzzle
	CALL DrawBars_Start
	CALL DrawBorders_Start
	
	LD HL,20480+130
	LD BC,28*256+3
	CALL DrawBorder
	LD HL,20480+180
	LD DE,MovesText
	CALL TypeText
	LD HL,20480+165
	LD DE,LockpickText
	CALL TypeText
	
		
	LD A,30
	LD (MovesPuzzle3),A
	CALL DisplayMoves_Puzzle3
	
;set lockpicks initial positions and other data
	LD A,0					;all bars aren't stuck at the start
	LD HL,StuckTable
	LD (HL),A
	LD DE,StuckTable+1
	LD BC,17
	LDIR
	
;copy initial lockpicks data
	LD HL,LockpicksData_Start
	LD DE,ChosenLockpick
	LD BC,17
	LDIR
	
;initial bar data
	LD HL,BarTipPositions_Free
	LD DE,BarTipPositions
	LD BC,18
	LDIR	

	HALT
	CALL DrawChosenLockpick
	CALL DrawLockpicks

;---	
PlayPuzzle3_Loop	
	CALL CheckPuzzle3Win		;check if winning the puzzle
	CALL CheckPuzzle3Lose
	
	CALL CheckQuit
	CALL GetPlayerInput
	
;control	
	BIT 4,A						;fire=change
	JP NZ,ChangeLockpicks

	BIT 0,A
	JP NZ,MoveLockpickRight
	
	BIT 1,A
	JP NZ,MoveLockpickLeft
	
	BIT 2,A
	JP NZ,MoveLockpickDown
	
	BIT 3,A
	JP NZ,MoveLockpickUp
	
	JP PlayPuzzle3_Loop	


;-----
MoveLockpickUp
;check if the movement is possible
	CALL GetLockpickHL		;put position into HL, length into D
	CALL HLGraphToAttr	
	LD B,D					;length into B
	INC B
	INC B					;add head
	
	LD DE,32
	SUB HL,DE				;go one attribute line up
;check all attribute square above lockpick if they are "empty"= attr 69
MoveLockpickUp1
	LD A,(HL)
	CP 69					;attribute of empty space?
	JP NZ,LockpickPushBarUp	;maybe pushing the bar
	INC L
	DJNZ MoveLockpickUp1
	
	
	
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)
	CP 32
	JP Z,PlayPuzzle3_Loop			;top movement edge 

	LD B,8
MoveLockpickUp2
	PUSH BC
	LD HL,(ChosenLockpickY_Addr)
	DEC (HL)				;go up
	HALT
	CALL DrawLockpicks
	POP BC
	DJNZ MoveLockpickUp2

;set bars blocked after movement of lockick
	CALL SetBarBlocked	
;maybe after lockpick movement some bar was released?
	CALL ReleaseFreeBars	
	JP PlayPuzzle3_Loop

;------------------
MoveLockpickDown
;check if the movement is possible
	CALL GetLockpickHL		;put position into HL, length into D
	CALL HLGraphToAttr	
	LD B,D					;length into B
	INC B
	INC B					;add head
	
	LD DE,32
	ADD HL,DE				;go one attribute line down
;check all attribute square below lockpick if they are "empty"= attr 69
MoveLockpickDown1
	LD A,(HL)
	CP 69						;attribute of empty space?
	JP NZ,LockpickPushBarDown	;maybe pushing the bar
	INC L
	DJNZ MoveLockpickDown1


	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)
	CP 112
	JP Z,PlayPuzzle3_Loop			;bottom movement edge

	LD B,8
MoveLockpickDown2
	PUSH BC
	LD HL,(ChosenLockpickY_Addr)
	INC (HL)				;go down
	HALT
	CALL DrawLockpicks
	POP BC
	DJNZ MoveLockpickDown2

;set bars blocked after movement of lockick
	CALL SetBarBlocked	
;maybe after lockpick movement some bar was released?
	CALL ReleaseFreeBars	
	JP PlayPuzzle3_Loop

;------------------	
MoveLockpickLeft
;no need to check if the move is blocked as it is always possible
	LD HL,(ChosenLockpickY_Addr)
	INC HL
	INC HL	
	LD A,(HL)						;read lockpick length
	CP 4
	JP Z,PlayPuzzle3_Loop			;shortest possible lockpick, don't move more


;move lockpick 2 chars left	
	CALL MoveLockpickLeft1
	CALL MoveLockpickLeft1

;set bars blocked after movement of lockick
	CALL SetBarBlocked	
;maybe after lockpick movement some bar was released?
	CALL ReleaseFreeBars	
	
	JP PlayPuzzle3_Loop
	
;-----
MoveLockpickLeft1
;move one char left - animation

;decrease length of lockpick by one char
	LD HL,(ChosenLockpickY_Addr)
	INC HL
	INC HL						;go to length data
	DEC (HL)					;decrease length
	
;change head and mask
	LD HL,HeadMask_7					
	LD (ChosenLockpickMask),HL
	
	LD HL,Head1_7
	LD A,(ChosenLockpick)
	OR A
	JR Z,MoveLockpickLeft2				
	LD HL,Head2_7

MoveLockpickLeft2				
	LD (ChosenLockpickHead),HL
	HALT
	CALL DrawLockpicks
	
	LD B,7
MoveLockpickLeft3
	PUSH BC
	LD HL,(ChosenLockpickHead)
	LD DE,24					;next head picture - rotated one pixel left
	SUB HL,DE
	LD (ChosenLockpickHead),HL
	
	LD HL,(ChosenLockpickMask)
	LD DE,30					;next mask
	SUB HL,DE
	LD (ChosenLockpickMask),HL
	
	HALT
	CALL DrawLockpicks
	POP BC
	DJNZ MoveLockpickLeft3
	RET

;------------------
MoveLockpickRight
;get lockpick head coordinates
	CALL GetHeadHL
;check using attribute if movement isn't blocked
	INC L
	INC L					;HL of square before lockpick head
	CALL HLGraphToAttr	
	
	LD A,(HL)
	CP 69					;get atrribute and compare to "empty" attribute
							;(cyan on black)
	JP NZ,PlayPuzzle3_Loop	;other attribute=movement is blocked


;move lockpick 2 chars right	
	CALL MoveLockpickRight1
	CALL MoveLockpickRight1
	
;set bars blocked after movement of lockick
	CALL SetBarBlocked
;maybe after lockpick movement some bar was released?
	CALL ReleaseFreeBars	
	JP PlayPuzzle3_Loop

;------
MoveLockpickRight1
;move one char right - animation
	LD B,7
MoveLockpickRight2
	PUSH BC
	LD HL,(ChosenLockpickHead)
	LD DE,24					;next head picture - rotated one pixel right
	ADD HL,DE
	LD (ChosenLockpickHead),HL
	
	LD HL,(ChosenLockpickMask)
	LD DE,30					;next mask
	ADD HL,DE
	LD (ChosenLockpickMask),HL
	
	HALT
	CALL DrawLockpicks
	POP BC
	DJNZ MoveLockpickRight2
	
;draw last 8 frame of animation at new character position
	;change head and mask
	LD HL,HeadMask_0					
	LD (ChosenLockpickMask),HL
	
	LD HL,Head1_0
	LD A,(ChosenLockpick)
	OR A
	JR Z,MoveLockpickRight3				
	LD HL,Head2_0

MoveLockpickRight3				
	LD (ChosenLockpickHead),HL
	
	
	;increase length of lockpick by one char
	LD HL,(ChosenLockpickY_Addr)
	INC HL
	INC HL						;go to length data
	INC (HL)					;increase length
	HALT
	CALL DrawLockpicks
	RET
	



		
;------------------
ChangeLockpicks
	CALL Sound1
	LD A,(ChosenLockpick)
	CPL						;0->255,255->0
	LD (ChosenLockpick),A
	
;swap lockpicks data	
	LD DE,(ChosenLockpickY_Addr)
	LD HL,(UnchosenLockpickY_Addr)
	LD (ChosenLockpickY_Addr),HL
	LD (UnchosenLockpickY_Addr),DE
	
	LD DE,(ChosenLockpickHead)
	LD HL,(UnchosenLockpickHead)
	LD (ChosenLockpickHead),HL
	LD (UnchosenLockpickHead),DE
	
	LD A,(ChosenLockpickBlockBar)
	LD B,A
	LD A,(UnchosenLockpickBlockBar)
	LD (ChosenLockpickBlockBar),A
	LD A,B
	LD (UnchosenLockpickBlockBar),A
	
	
	CALL DrawLockpicks
	CALL DrawChosenLockpick
	
	JP PlayPuzzle3_Loop

;------------------
DrawChosenLockpick
;draw chosen lockpick in the menu
;clear old lockpick sprite
	LD D,0
	LD HL,20480+174
	LD B,8
DrawChosenLockpick2
	LD (HL),D
	INC L
	LD (HL),D
	INC L
	LD (HL),D
	DEC L
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawChosenLockpick2
		

;draw chosen lockpick in the menu
	LD HL,(ChosenLockpickHead)
	LD DE,24*7		;go to image of head shifted 7 pixels right
	ADD HL,DE
	EX HL,DE
	
	LD HL,20480+174
	CALL DrawLockpickHead
	RET
	
;------------------
DrawLockpicks

;draw unchosen lockpick handle
	LD HL,(UnchosenLockpickY_Addr)	
	LD A,(HL)				;get lockpick Y
	
	INC A					;handle is 2 pixel lower than head
	INC A
		
	LD C,A					;coordinates in BC
	LD B,0
	
	INC HL
	INC HL
	LD D,(HL)				;get handle length
		
	CALL XYtoHL				;coordinates in HL	
	
	LD E,255
	LD C,4					;number of pixel lines
	
DrawLockpicks1	
	LD B,D					;restore length
	PUSH HL
	
DrawLockpicks2
	LD (HL),E				;one pixel line
	INC L
	DJNZ DrawLockpicks2
	
	POP HL					;restore position (leftmost byte)
	CALL OnePixelLineDown
	
	DEC C
	JR NZ,DrawLockpicks1	

;------------	
;draw unchosen lockpick head
	LD HL,(UnchosenLockpickY_Addr)
	LD A,(HL)
	LD C,A					;coordinates in BC
	LD B,0
	INC HL
	INC HL
	LD A,(HL)				;go to and get lockpick length
	LD D,A
		
	CALL XYtoHL
	LD A,D					;get lockpick length
		
	ADD A,L					;and add to the beginning position of the handle
	LD L,A
	
	LD DE,(UnchosenLockpickHead)
	CALL DrawLockpickHead
	
		
;----------------
;draw chosen lockpick handle
	CALL GetLockpickHL		;put position into HL, length into D
	LD C,6					;number of pixel lines (4-lockpick, 2-mask)
	EXX
	LD HL,LockpickHandleBytes
	EXX
	
DrawLockpicks3
	EXX
	LD A,(HL)				;lockpick graphics
	INC HL
	EXX

	LD B,D					;restore length
	PUSH HL
	
DrawLockpicks4
	LD (HL),A				;one pixel line
	INC L
	DJNZ DrawLockpicks4
	
	POP HL					;restore position (leftmost byte)
	CALL OnePixelLineDown
	
	DEC C
	JR NZ,DrawLockpicks3
	
	
;--------------	
;draw chosen lockpick head

;mask
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)				;get head Y
	DEC A					;adjust for mask
	LD C,A					;coordinates in BC
	LD B,0
	
	INC HL
	INC HL
	LD A,(HL)				;go to and get lockpick length
	LD D,A
	
	CALL XYtoHL
	
	LD A,D					;handle length
	ADD A,L					;add to the beggining of handle
	LD L,A
	
	LD DE,(ChosenLockpickMask)
	LD B,10
DrawLockpicks45
	LD A,(DE)				;read mask
	AND (HL)				;combine with background
	LD (HL),A				;and write
	INC DE
	INC L
	
	LD A,(DE)
	AND (HL)
	LD (HL),A
	INC DE
	INC L
	
	LD A,(DE)
	AND (HL)
	LD (HL),A
	INC DE
	DEC L
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawLockpicks45

;sprite
	CALL GetHeadHL
	LD DE,(ChosenLockpickHead)	
	CALL DrawLockpickHead

	RET
;-------
DrawLockpickHead
	;HL position,DE graphics
	
	LD B,8
DrawLockpickHead2
	LD A,(DE)
	OR (HL)
	LD (HL),A
	INC DE
	INC L
	
	LD A,(DE)
	OR (HL)
	LD (HL),A
	INC DE
	INC L
	
	LD A,(DE)
	OR (HL)
	LD (HL),A
	INC DE
	DEC L
	DEC L
	CALL OnePixelLineDown
	DJNZ DrawLockpickHead2	
	RET
	
;---------------
GetLockpickHL
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)				;get lockpick Y
	INC A					;handle is 2 pixel lower than head
							;but one line goes for empty line - mask
		
	LD C,A					;coordinates in BC
	LD B,0
	INC HL
	INC HL
	LD D,(HL)				;go to and get handle length
	
	CALL XYtoHL				;coordinates into HL (HL style)
;HL-lockpick position,D lockpick length
	RET

GetHeadHL
	LD HL,(ChosenLockpickY_Addr)
GetHeadHL2
	LD C,(HL)
	LD B,0
	INC HL
	INC HL
	LD D,(HL)				;lockpick length
	CALL XYtoHL				;HL of lockpick handle
	LD A,L
	ADD A,D
	LD L,A					;HL of lockpick head
	RET	
	
	
;---------------
LockpickPushBarUp
;lockpick while moving up was blocked
;it maybe pushing a bar with its head trying to push it
;but there are other possibilities

;check if pushing bar is possible
	CALL GetHeadHL
	CALL HLGraphToAttr
	LD DE,32						;one line of atttrs above lockpick head
	SUB HL,DE
	LD A,(HL)
	CP 69							;empty space?
	JP Z,PlayPuzzle3_Loop			;lockpick head not pushing tip of any bar, do nothing
	
	LD HL,(ChosenLockpickY_Addr)
	INC HL
	INC HL							;go to and get lockpick length
	LD A,(HL)
	CP 8
	JP C,PlayPuzzle3_Loop			;lockpick too short to push anything

	;find bar number (length 8- bar 1,10-2,12,3 etc.)
	SUB 8 							;(0-1,2-2,4-3,6-4 etc.)
	SRL A							;a=a/2 (0-1 1-2 2-3 4-4)
	INC A							;bar number found
	LD (BarNumber),A
	
;check if all bars left from our bar are not blocking the way
	CP 1
	JR Z,LockpickPushBarUp12		;1st bar, no bars left of it to block way
	DEC A							;if we push e.g. 3rd bar, we check 2 bars left of it
	LD HL,BarTipPositions-1
	LD B,A
LockpickPushBarUp11
	INC HL							;check next bar
	LD A,(HL)
	CP 24							;minimal length of  bar, only this length doesn't block the way
	JP NZ,PlayPuzzle3_Loop			;some other bar is blocking the movement
	DJNZ LockpickPushBarUp11

LockpickPushBarUp12					;checking if bar isn't already pushed
	LD A,(BarNumber)
	LD HL,BarTipPositions-1
	LD E,A
	LD D,0
	ADD HL,DE						;address of bar length (Y position of its tip)
	LD A,(HL)						;get length
	CP 24							;minimum length
	JP Z,LockpickUnstuckBar			;bar already pushed, pushing it up means
									;unstucking it (if stuck) or nothing
	
	
	SUB 24							;24 - position of bar maximally pushed
									;by subtracting it from current position we get the path length
	SRL A							;as we move by 2 pixels we must divide it by 2
	LD B,A
LockpickPushBarUp2
;moving both lockpick and bar two pixels up
	PUSH BC
	HALT
	HALT
	LD HL,(ChosenLockpickY_Addr)	;lockpick one pixel up
	DEC (HL)				
	CALL DrawLockpicks
	
	LD A,(BarNumber)				;bar two pixels up
	LD C,A
	CALL MoveBarUp
	
	LD HL,(ChosenLockpickY_Addr)	;lockpick one pixel up
	DEC (HL)				
	CALL DrawLockpicks
	
	;draw "empty" cyan attribute
	CALL GetHeadHL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,69
	LD (HL),A
	INC L
	LD (HL),A

	POP BC
	DJNZ LockpickPushBarUp2

;write that lockpick blocks now bar nr N
	LD A,(BarNumber)
	LD (ChosenLockpickBlockBar),A
	

;decrease number of moves
	LD HL,MovesPuzzle3
	DEC (HL)
	CALL DisplayMoves_Puzzle3	
	
	JP MoveOtherBars
	
	
;---------------
;---------------
LockpickPushBarDown
	;check if pushing bar is possible
	CALL GetHeadHL
	CALL HLGraphToAttr
	LD DE,32						;one line of atttrs below lockpick head
	ADD HL,DE
	LD A,(HL)
	CP 69							;empty space?
	JP Z,PlayPuzzle3_Loop			;lockpick head not pushing tip of any bar, do nothing
	
	LD HL,(ChosenLockpickY_Addr)
	INC HL
	INC HL							;go to and get lockpick length
	LD A,(HL)
	CP 8
	JP C,PlayPuzzle3_Loop			;lockpick too short to push anything

	;find bar number (length 8- bar 10,10-11,12-12 etc.)
	SUB 8 							;(0-10,2-11,4-12,6-13 etc.)
	SRL A							;a=a/2 (0-10 1-11 2-12 3-13)
	ADD A,10							;bar number found
	LD (BarNumber),A
	
;check if all bars left from our bar are not blocking the way
	CP 10
	JR Z,LockpickPushBarDown12		;10=nr of 1st bar in bottom row, no bars left of it to block way
	SUB 10							;if we push e.g. 12rd bar (3th in bottom), we check 2 bars left of it
	LD HL,BarTipPositions+8
	LD B,A
LockpickPushBarDown11
	INC HL							;check next bar
	LD A,(HL)
	CP 120							;minimal length of  bar (its tip postition), only this length doesn't block the way
	JP NZ,PlayPuzzle3_Loop			;some other bar is blocking the movement
	DJNZ LockpickPushBarDown11
	
LockpickPushBarDown12				;checking if bar isn't already pushed
	LD A,(BarNumber)
	LD HL,BarTipPositions-1
	LD E,A
	LD D,0
	ADD HL,DE						;address of bar length (Y position of its tip)
	LD A,(HL)						;get length
	CP 120							;minimum length
	JP Z,LockpickUnstuckBar			;bar already pushed, pushing it up means
									;unstucking it (if stuck) or nothing
	
	LD B,A
	LD A,120
	SUB B							;120 - position of bar maximally pushed
									;by subtracting it from current position we get the path length
	SRL A	
	LD B,A							;as we move by 2 pixels we must divide it by 2
LockpickPushBarDown2
;moving both lockpick and bar two pixels down
	PUSH BC
	HALT
	HALT
	LD HL,(ChosenLockpickY_Addr)	;lockpick one pixel down
	INC (HL)				
	CALL DrawLockpicks
	
	LD A,(BarNumber)				;bar two pixels up
	LD C,A
	CALL MoveBarDown
	
	LD HL,(ChosenLockpickY_Addr)	;lockpick one pixel down
	INC (HL)				
	CALL DrawLockpicks
	
	;draw "empty" cyan attribute
	CALL GetHeadHL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD DE,32
	ADD HL,DE
	LD D,(HL) 						;store bar attribute
	LD A,69
	LD (HL),A
	INC L
	LD (HL),A
	POP BC
	DJNZ LockpickPushBarDown2
	
	LD (HL),D						;restore bar attribute when moving is over
	DEC L
	LD (HL),D

;write that lockpick blocks now bar nr N
	LD A,(BarNumber)
	LD (ChosenLockpickBlockBar),A
	
;decrease number of moves
	LD HL,MovesPuzzle3
	DEC (HL)
	CALL DisplayMoves_Puzzle3	
	JP MoveOtherBars


;----------------------------
SetBarBlocked
;check if after a movement lockpick blocks any bar
	LD HL,(ChosenLockpickY_Addr)
	LD A,(HL)						;get lockpick Y
	CP 32							;is lockpick at topmost position?
	JR Z,SetBarBlocked_Top
	CP 112
	JR Z,SetBarBlocked_Bottom		;is at bottom position
	
	XOR A 
	LD (ChosenLockpickBlockBar),A	;neither top or bottom position so not blocking anything
	RET
;-----------	
SetBarBlocked_Top
	INC HL
	INC HL
	LD A,(HL)						;get lockpick length
	CP 8					
	JR NC,SetBarBlocked_Top2
;lockpick too short - don't block anything	
	XOR A 
	LD (ChosenLockpickBlockBar),A	
	RET

SetBarBlocked_Top2
;get bar number (1-9)
	SUB 8
	SRL A
	INC A
	LD (ChosenLockpickBlockBar),A	
	RET

;---------------
SetBarBlocked_Bottom
	INC HL
	INC HL
	LD A,(HL)						;get lockpick length
	CP 8					
	JR NC,SetBarBlocked_Bottom2
;lockpick too short - don't block anything	
	XOR A 
	LD (ChosenLockpickBlockBar),A	
	RET

SetBarBlocked_Bottom2
	;get bar number (10-19)
	SUB 8
	SRL A
	ADD A,10
	LD (ChosenLockpickBlockBar),A	
	RET
	
;--------------------------
LockpickUnstuckBar
;pushing a bar which is already pushed
;if bar stuck ->unstuck it
;if not -> do nothing


;check if the  bar is stuck	
	LD A,(BarNumber)
	LD B,A
	LD HL,StuckTable-1
LockpickUnstuckBar2
	INC HL							;find stuck data in the table
	DJNZ LockpickUnstuckBar2
	LD A,(HL)
	OR A
	JP Z,PlayPuzzle3_Loop			;not stuck do nothing
	
	LD A,(BarNumber)				;make the bar unstuck
	LD C,A
	CALL SetBarUnstuck
	CALL Sound3

	JP PlayPuzzle3_Loop
	
	
;	ORG 50000

;--------
BarNumber .BYTE 0

LockpickHandleBytes
	.BYTE 0,255,255,255,255,0	
	
ChosenLockpick		.BYTE 0		;0-lockpick 1, 255-lockpick 2
	
LockpickA_Y			.BYTE 0		
LockpickB_Y			.BYTE 0		

LockpickA_Length	.BYTE 0		;length in bytes
LockpickB_Length	.BYTE 0


ChosenLockpickY_Addr	.WORD 0
UnchosenLockpickY_Addr	.WORD 0

ChosenLockpickMask		.WORD 0
ChosenLockpickHead		.WORD 0
UnchosenLockpickHead	.WORD 0


ChosenLockpickBlockBar		.BYTE 0		;which bar is blocked by current lockpick (0-none) ;50022
UnchosenLockpickBlockBar	.BYTE 0
	 
LockpicksData_Start
		.BYTE 0
		.BYTE 64
		.BYTE 88
		.BYTE 4
		.BYTE 4
		
		.WORD LockpickA_Y
		.WORD LockpickB_Y
		
		.WORD HeadMask_0
		.WORD Head1_0
		.WORD Head2_0
		
		.BYTE 0
		.BYTE 0


		