;--------------	
DrawBorders_Start
	LD HL, 16384+6
	LD DE,Puzzle3_Border1
	CALL DrawTile
	
	LD HL, 18432+230
	LD DE,Puzzle3_Border2
	CALL DrawTile
	
	LD HL,16384+8
	CALL DrawBorders_Start2
	LD HL,20480+40
	CALL DrawBorders_Start2
	
	LD HL,16384+26
	LD DE,Puzzle3_Border4
	CALL DrawTile
	LD HL,20480+90
	LD DE,Puzzle3_Border6
	CALL DrawTile
	
	LD B,17
	LD HL,16384+58
DrawBorders_Start11
	PUSH BC
	PUSH HL
	LD DE,Puzzle3_Border5
	CALL DrawTile
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	JR NC,DrawBorders_Start12
	LD A,H
	ADD A,8
	LD H,A
DrawBorders_Start12
	POP BC
	DJNZ DrawBorders_Start11
	
	LD HL,16384+60
	LD DE,Puzzle3_Border7
	CALL DrawTile
	LD HL,20480+28
	LD DE,Puzzle3_Border7
	CALL DrawTile
	RET

;----
DrawBorders_Start2	
	LD B,9
DrawBorders_Start3
	PUSH HL
	PUSH BC
	LD DE,Puzzle3_Border3
	CALL DrawTile
	POP BC
	POP HL
	INC L
	INC L
	DJNZ DrawBorders_Start3
	RET

;--------------
DrawBars_Start

;draw top line of bars
	LD HL,16384+72
	LD DE,BarTopLength_Start
	LD B,3
	
DrawBars_Start2
	PUSH BC

	PUSH HL					;3x  3 bars
	PUSH DE
	CALL DrawBarA
	POP DE
	POP HL
	INC DE					;height of next bar
	INC L
	INC L					;position of next bar
	
	PUSH HL
	PUSH DE
	CALL DrawBarA
	POP DE
	POP HL
	INC DE					;height of next bar
	INC L
	INC L					;position of next bar
	
	PUSH HL
	PUSH DE
	CALL DrawBarB
	POP DE
	POP HL
	INC DE					;height of next bar
	INC L
	INC L					;position of next bar

	POP BC
	DJNZ DrawBars_Start2
	
;draw bottom line of bars
	LD HL,20480+8
	LD DE,BarBottomLength_Start
	LD B,3
	
DrawBars_Start3
	PUSH BC

	PUSH HL					;3x  2 bars (empty space between bottom bars)
	PUSH DE
	CALL DrawBarC
	POP DE
	POP HL
	INC DE					;height of next bar
	INC L
	INC L					;position of next bar
	
	PUSH HL
	PUSH DE
	CALL DrawBarC
	POP DE
	POP HL
	INC DE					;height of next bar
	INC DE					;(skip 0 -height of empty bar
	INC L
	INC L
	INC L
	INC L					;position of next bar
	
	POP BC
	DJNZ DrawBars_Start3
;attributes
	
;top bars	
	LD IX,BarTopLength_Start
	LD DE,31
	LD HL,88*256+72
	LD B,9
DrawBarsStart4	
	LD A,(IX+0)
	LD C,A			;read bar length
	LD A,(IX+18)    ;read bar color
	
	PUSH HL
DrawBarsStart5
	LD (HL),A		;paint one line of attrs
	INC L
	LD (HL),A
	ADD HL,DE		;go one line down
	DEC C
	JR NZ,DrawBarsStart5
	
	POP HL
	INC L
	INC L			;go to next bar
	INC IX			;next bar data
	DJNZ DrawBarsStart4
	
;bottom bars	
	LD IX,BarBottomLength_Start
	LD DE,33
	LD HL,90*256+8
	LD B,9
DrawBarsStart6
	LD A,(IX+0)
	OR A
	JR Z,DrawBarsStart8		;skip if empty bar
	
	LD C,A			;read bar length
	LD A,(IX+9)    ;read bar color
	
	PUSH HL
DrawBarsStart7
	LD (HL),A		;paint one line of attrs
	INC L
	LD (HL),A
	SUB HL,DE		;go one line up
	DEC C
	JR NZ,DrawBarsStart7
	
	POP HL
DrawBarsStart8	
	INC L
	INC L			;go to next bar
	INC IX			;next bar data
	DJNZ DrawBarsStart6
	RET
	
;-----------------	
;-------------
DrawBarA
	;normal bar, top position
	;HL-position
	;DE-height address (char lines)

	LD A,(DE)							;read height	
	DEC A								;height=height-1 as one segment is tip, draw separately
	
DrawBarA2
	PUSH AF
	PUSH HL
	LD DE,BarA
	CALL DrawTile
	POP HL
	CALL OneCharLineDown
	POP AF
	DEC A								;decrease number of character lines left to do
	JR NZ,DrawBarA2
	
	LD DE,BarA_Top1					;draw tip of bar
	CALL DrawTile
	RET
	
;-------------
DrawBarB
	;special bar, top position
	;HL-position
	;DE-height address (char lines)

	LD A,(DE)							;read height	
	DEC A								;height=height-1 as one segment is tip, draw separately
	
DrawBarB2
	PUSH AF
	PUSH HL
	LD DE,BarB
	CALL DrawTile
	POP HL
	CALL OneCharLineDown
	POP AF
	DEC A								;decrease number of character lines left to do
	JR NZ,DrawBarB2
	
	LD DE,BarB_Top					;draw tip of bar
	CALL DrawTile
	RET
	
;-------------
DrawBarC
	;normal bar, bottom position
	;HL-position
	;DE-height address (char lines)

	LD A,(DE)							;read height	

	DEC A								;height=height-1 as one segment is tip, draw separately
	
DrawBarC2
	PUSH AF
	PUSH HL
	LD DE,BarA
	CALL DrawTile
	POP HL
	CALL OneCharLineUp
	POP AF
	DEC A								;decrease number of character lines left to do
	JR NZ,DrawBarC2
	
	LD DE,BarA_Top2					;draw tip of bar
	CALL DrawTile
	RET	
	
;-------------------
CheckPuzzle3Win
;winning the puzzle = all bars stuck
	LD HL,StuckTable
	LD B,1
	
CheckPuzzle3Win2
	LD A,B
	CP 12						;skip checking of unexisting bars
	JR Z,CheckPuzzle3Win3
	CP 15
	JR Z,CheckPuzzle3Win3
	CP 18
	JR Z,CheckPuzzle3Win3
	
	LD A,(HL)					;is bar stuck?
	OR A
	RET Z						;0=not stuck = no win, back to main loop

CheckPuzzle3Win3
	INC HL						;next bar
	INC B
	LD A,B
	CP 19
	JR NZ,CheckPuzzle3Win2
	
;all bar checked and all are stuck=winning the puzzle
	CALL Sound2
	CALL FadeOut
	CALL DrawEndOfLevelScreen
	JP Ending
	
;----------------
CheckPuzzle3Lose
	LD A,(MovesPuzzle3)
	OR A
	JP Z,GameOver
	RET
